// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ HP 48 Examples from the TEACH command
@ CLTEACH will erase the examples
@ in one big directory
//
/Var EXAMPLES
DIR
   PRGS DIR                            @ < < < < < < <
      MEDIAN                           @ < < <
      \<<
         RCL\GS DUP SIZE OBJ\-> DROP
         \-> s n m
         \<<
            '\GSDAT' TRN 1 m
            FOR j
               \GS- OBJ\-> DROP n \->LIST 50 %TILE j ROLLD
            NEXT
            m \->ARRY s STO\GS
         \>>
      \>>
      FIBON                            @ < < <
      \<<
         IF n 1 \<=
         THEN
            n
         ELSE
            0 1
            2 n
            START
               DUP ROT +
            NEXT
            DROP
         END
      \>>
      APLY                             @ < < <
      \<<
         \-> a p
         \<<
            1 CF a DUP SIZE DUP SIZE
            IF 1 ==
            THEN
               1 SF 1 + SWAP OBJ\-> OBJ\-> DROP 1 + ROLL
            ELSE
               DROP2 a OBJ\->
            END
            DUP OBJ\-> DROP * SWAP OVER 2 + ROLLD \->LIST
            1 p DOSUBS OBJ\-> 1 + ROLL
            IFERR
               IF 1 FS?
               THEN
                  OBJ\-> DROP \->LIST
               END
               \->ARRY
            THEN
               OBJ\->
               IF 1 FC?C
               THEN
                  DROP
               END
               \-> n m
               \<<
                  1 n
                  FOR i
                     m \->LIST 'm*(n -i)+i' EVAL ROLLD    NEXT n \->LIST
               \>>
            END
            1 CF
         \>>
      \>>
      \->RPN                           @ < < <
         \<<
            OBJ\->
            IF OVER
            THEN
               \-> n f
               \<<
                  1 n
                  FOR i
                     IF DUP TYPE 9 SAME
                     THEN
                        \->RPN
                     END
                     n ROLLD
                  NEXT
                  IF DUP TYPE 5 \=/
                  THEN
                     1 \->LIST
                  END
                  IF n 1 >
                  THEN
                     2 n
                     START
                        +
                     NEXT
                  END
                  f +
               \>>
            ELSE
               1 \->LIST SWAP DROP
            END
         \>>
   END
   PLOTS DIR                           @ < < < < < <
   DIR
       XSIN                            @ < < <
      \<<
         RAD
         { PICT PPAR } PURGE
         'X+SIN(2*X)' STEQ
         DRAX DRAW PICTURE
      \>>
      ELLIP                            @ < < <
      \<<
         { PICT PPAR } PURGE
         CONIC
         .01 RES
         { X -2 2 } INDEP
         '5*X^2+3*Y^2-18' STEQ
         DRAX DRAW PICTURE
      \>>
      LISSA                            @ < < <
      \<<
         { PICT PPAR } PURGE
         RAD PARAMETRIC
         { T 0 6.5 } INDEP
         '3*SIN(3*T)+i*2*SIN(4*T)' STEQ
         DRAX DRAW PICTURE
      \>>
      ROSE                             @ < < <
      \<<
         RAD
         { PICT PPAR } PURGE
         POLAR
         \Gh INDEP
         '2* COS(4*\Gh)' STEQ
         DRAX DRAW PICTURE
      \>>
      PTRN                             @ < < <
      \<<
      RAD
      { PICT PPAR } PURGE
      TRUTH
      '(X^2+Y^3)MOD4<2' STEQ
      DRAX DRAW PICTURE
      \>>
      DEQ                              @ < < <
      \<<
         \<<
            Y OBJ\-> DROP T 5 * COS 12 * ROT 49 * - 2 \->ARRY
         \>>
         STEQ
         RAD
         { PICT PPAR } PURGE
         DIFFEQ
         -2 2 XRNG
         -8 8 YRNG
         { T 0 3.14159265359 } INDEP
         { Y [ 0 0 ] .001 } DEPND
         { (0,0) "1" "2" } AXES
         .05 RES
         DRAX DRAW PICTURE
      \>>
      SPFLD                            @ < < <
      \<<
         RAD
         { PICT PPAR VPAR } PURGE
         SLOPEFIELD
         '(X^2-1)/(Y^2-1)' STEQ
         16 NUMX
         16 NUMY
         -2 2 XVOL
         -2 2 YVOL
         DRAW PICTURE
      \>>
      PSCN                             @ < < <
      \<<
         RAD
         { PICT PPAR VPAR } PURGE
         PCONTOUR
         '(X^2-1)/(Y^2-1)' STEQ
         16 NUMX
         16 NUMY
         -2 2 XVOL
         -2 2 YVOL
         DRAW PICTURE
      \>>
      GRID                             @ < < <
      \<<
         RAD
         { PICT PPAR VPAR } PURGE
         GRIDMAP
         'SIN((X,Y))' STEQ
         DRAW PICTURE
      \>>
      PSUR                             @ < < <
      \<<
         RAD
         { PICT PPAR VPAR } PURGE
         PARSURFACE
         { 'X*COS(Y)' 'X*SIN(Y)' X } STEQ
         16 NUMX
         16 NUMY
         -3.14159 3.14159 DUP2 DUP2 4 DUPN XVOL YVOL ZVOL
         XXRNG YYRNG
         0 -4.2 0 EYEPT
         DRAW PICTURE
      \>>
      WIRE                             @ < < <
      \<<
         { PICT PPAR VPAR } PURGE
         WIREFRAME
         'X^3*Y-X*Y^3' STEQ
         12 NUMX
         12 NUMY
         -.4 .4 ZVOL
         0 -2 1 EYEPT
         DRAW PICTURE
      \>>
      SLICE                            @ < < <
        \<<
         RAD
         { PICT PPAR VPAR } PURGE
         YSLICE
         'X^3*Y-X*Y^3' STEQ
         -.5 .5 ZVOL
         DRAW
      \>>
   END
   EQNS DIR                            @ < < < < < <
      ONE                              @ < < <
         'SIN(X)'
      TWO                              @ < < <
         '2*SIN(X)'
      THREE                            @ < < <
         '3*SIN(X)'
      FOUR                             @ < < <
         '4*SIN(X)'
      RATFUNC                          @ < < <
         '6/(x^2-9)+4/(6+x-x^2)+2\047(x^2+5*x+6)'
   END
   %TILE                               @ < < <
   \<<
      SWAP SORT DUP SIZE 1 + ROT 100 / *
      \-> p
      \<<
         DUP p FLOOR GET SWAP p CEIL GET + 2 /
      \>>
    \>>
   PURGEX                              @ < < <
      \<<
         HOME 'EXAMPLES' PGDIR
      \>>
END
