// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ PRGMS < < < < <
@ FIND
@ HPJD
@ JULIAN
@ MAG
@ R\Ghp\->
@ R\Gh\->
@ SDISP
@ SPLOT
@ STAR
@ STAR\Gh
@ TIM\Gh
@ XLAT
@ XLAT2
@ XYZ\->
@ XY\->
@ disp
@ gdisp
@ \->UV
@ \->UV2
@ \->UV3

@ VARS  < < < < <
@ LAT
@ S.D
@ S.M
@ S.N
@ S.S
@ S.\Gh
@ X.D
@ X.\Ga
@ X.\Gh
@ wst
@ xcl
@ \Gh
@ S.A
@ S.V
@ X.V
@ \GSDAT
@ PPAR
@ STARS
@ astro
@ \GSPAR
@ CST
@ EQ
//
/Var FIND
\<<
   CLLCD -1
   \-> q t
   \<<
      'STARS' 1
      DO
         "# " OVER + 1 DISP GETI HEAD OBJ\-> OBJ\->
         \-> a n
         \<<
            IF
               a q ==
            THEN
               -64 SF n 't' STO
            END
          \>>
      UNTIL
         -64 FS?
      END
      DROP2
      IF
         t -1 >
      THEN
         t SDISP
      ELSE
         "Error:" 10 CHR + "Not Found" + DOERR
      END
   \>>
\>>
//
/Var HPJD
\<<
   TICKS B\->R 707788800 /
\>>
//
/Var JULIAN
\<<
   RCLF DATE TIME TSTR HPJD
   \-> f s j
   \<<
      11 ENG
      j xcl + "XCL" \->TAG
      j " HP" \->TAG
      j wst + "WST" \->TAG CLLCD 7 5
      FOR n n
         DISP -1
      STEP s 3
      DISP 2 FREEZE
      f STOF
   \>>
\>>
//
/Var MAG
\<<
   S.M -.63829787234 * 1.97872340426 + R\->B
\>>
//
/Var R\Ghp\->
\<<
   SPHERE \->V3 RECT V\->
\>>
//
/Var R\Gh\->
\<<
   SPHERE \->V2 RECT V\->
\>>
//
/Var SDISP
\<<
   STAR
   { S.N S.A S.M S.S S.\Gh S.D }
   disp
\>>
//
/Var SPLOT
\<<
   DEG SPHERE P.STD VIEW0 30 30 SCALE (-45,0) CENTR 30 ATICK
   "Star" 3 3 1 GDISP
   "Plot" 3 4 1 GDISP
   "BY LIZ" 1 8 1 GDISP
   (0,0) 93 0 360 ARC 'LAT' rcl 1 1 1 GDISP
   '\Gh' rcl 1 2 1 GDISP
   0 57
   FOR n
      n 1 1 31 GDISP
      "STAR" 1 10.8 29 GDISP
      n STAR "XLAT" 1 10.8 29 GDISP
      XLAT
      IF
         X.D 0 \>=
      THEN
         "PLOT" 1 10.8 29 GDISP
         S.A " " 15 S.A SIZE - RPT + 1 10.8 1 GDISP
         X.V V\-> ROT DROP SWAP 90 - \->V2
         OBJ\-> DROP R\->C C\->PX MAG
         0 360 ARC
      END
   NEXT
   " " 2 RPT 1 1 31 GDISP
   " " 4 RPT 1 10.8 29 GDISP
   " " 15 RPT 1 10.8 1 GDISP
   VIEW
\>>
//
/Var STAR
\<<
   \-> n
   \<<
      n 1 + 'STARS' SWAP
      IFERR
         GET THEN DROP2 n "Error: Star # Not Found" DOERR
      ELSE
         OBJ\-> DROP 'S.D' STO
         360 OVER - 360 MOD 'S.\Gh' STO
         'S.S' STO
         'S.M' STO
         OBJ\-> OBJ\-> 'S.N' STO
         'S.A' STO 1 S.\Gh 90 S.D - SPHERE \->V3 'S.V' STO
      END
   \>>
\>>
//
/Var STAR\Gh
\<<
   CLLCD # 82h
   IF
      21 FS?
   THEN
      # 5Ah
   ELSE
      # 3Fh
   END
   PDIM "Star Xlat" DUP { S.N LAT \Gh } inform
   IF
      0 ==
   THEN
      DROP KILL
   END
   CLLCD S.N STAR XLAT S.A S.N \->TAG { S.\Gh S.D X.\Gh X.\Ga X.D LAT \Gh } rcl + +
   IF
      21 FS?
   THEN
      3
   ELSE
      1
   END
   gdisp
   IF
      21 FS?
   THEN
      PRPICT EJECT
   END
\>>
//
/Var TIM\Gh
\<<
   HPJD .99769566435 MOD 360 * 53.7 - 360 MOD '\Gh' STO
   "Latitude & \Gh"
   { LAT \Gh }
   input
\>>
//
/Var XLAT
\<<
   S.V SPHERE V\->
   \-> r t p
   \<<
      r t \Gh - p R\Ghp\->
      \-> x y z
      \<<
         z x XY\-> 90 LAT - - R\Gh\-> y ROT XYZ\-> \->V3 'X.V' STO
         X.V V\-> 90 SWAP - 'X.D' STO
         360 MOD 'X.\Gh' STO
         180 X.\Gh - 360 MOD
         'X.\Ga' STO
         DROP
      \>>
   \>>
\>>
//
/Var XLAT2
\<<
\>>
//
/Var XYZ\->
\<<
   RECT \->V3 SPHERE V\->
\>>
//
/Var XY\->
\<<
   RECT \->V2 SPHERE V\->
\>>
//
/Var disp
\<<
   CLLCD 1
   \<<
      IF
         DUP TYPE 6 ==
      THEN
         DUP VTYPE
      ELSE
         -1
      END
      \-> t
      \<<
         IF
            t 0 == t 2 == OR
         THEN
            rcl
         END
         NSUB DISP
      \>>
   \>>
   DOSUBS
   3 FREEZE
\>>
//
/Var gdisp
\<<
   \-> n
   \<<
      VIEW0 1
      \<<
         n NSUB 1 GDISP
      \>>
      DOSUBS
   \>>
   VIEW3
\>>
//
/Var \->UV
\<<
   DUP ABS /
\>>
//
/Var \->UV2
\<<
   IF
      -16 FS?
   THEN
      \-> r t
      \<<
         1 t
      \>>
   ELSE
      \->V2 \->UV V\->
   END
\>>
//
/Var \->UV3
\<<
   IF
      -16 FS?
   THEN
      \-> r t p
      \<<
         1 t p
      \>>
   ELSE
   \->V3 \->UV V\->
   END
\>>
//
/Var LAT
45
//
/Var S.D
16.54
//
/Var S.M
1.1
//
/Var S.N
10
//
/Var S.S
290.77
//
/Var S.\Gh
69.23
//
/Var X.D
39.0498983428
//
/Var X.\Ga
252.9740072
//
/Var X.\Gh
287.0259928
//
/Var wst
1721059.5
//
/Var xcl
-693959
//
/Var \Gh
120
//
/Var S.A
"ALDEBARAN"
//
/Var S.V
[ .339943803526 .896321848449 .284684657889 ]
//
/Var X.V
[ .227392057061 -.742560893938 .629996961247 ]
//
/Var \GSDAT
[
   [ 3.1 0 ]
   [ -1.6 3 ]
]
//
/Var PPAR
{ (-240,-93) (150,96) X 0 { (0,0) 30 } FUNCTION Y }
//
/Var STARS
{
   { :00: "POLARIS" 3 0 90 }
   { :01: "ALPHERATZ"        2.2 357.68  29.19 }
   { :02: "ANKAA"            2.4 353.73 -42.43 }
   { :03: "SCHEDAR"          2.5 350.22  56.40 }
   { :04: "DIPHDA"           2.2 348.88 -18.39 }
   { :05: "ACHERNAR"         0.6 335.41 -57.61 }
   { :06: "HAMAL"            2.2 327.96  23.54 }
   { :07: "ACAMAR"           3.1 315.27 -40.60 }
   { :08: "MENKAR"           2.8 314.75   4.00 }
   { :09: "MIRFAK"           1.9 308.61  49.92 }
   { :10: "ALDEBARAN"        1.1 290.77  16.54 }
   { :11: "RIGEL"            0.3 281.16  -8.29 }
   { :12: "CAPELLA"          0.2 280.50  46.02 }
   { :13: "BELLATRIX"        1.7 279.05   6.33 }
   { :14: "ELNATH"           1.8 278.82  28.58 }
   { :15: "ALNILAM"          1.8 276.27  -1.22 }
   { :16: "BETELGEUSE"       0.7 270.96   7.41 }
   { :17: "CANOPUS"         -0.9 263.92 -52.66 }
   { :18: "SIRIUS"          -1.6 258.52 -16.62 }
   { :19: "ADHARA"           1.6 255.58 -28.93 }
   { :20: "PROCYON"          0.5 244.95   5.18 }
   { :21: "POLLUX"           1.2 243.40  27.98 }
   { :22: "AVIOR"            1.7 234.50 -59.43 }
   { :23: "SUHAIL"           2.2 222.84 -43.14 }
   { :24: "MIAPLACIDUS"      1.8 221.77 -69.62 }
   { :25: "ALPHARD"          2.2 217.89  -8.34 }
   { :26: "REGULUS"          1.3 207.67  11.89 }
   { :27: "DUBHE"            2.0 193.80  61.66 }
   { :28: "DENEBOLA"         2.2 182.52  14.47 }
   { :29: "GIENAH"           2.8 176.37 -17.42 }
   { :30: "ACRUX"            1.1 173.11 -62.69 }
   { :31: "GACRUX"           1.6 172.55 -56.98 }
   { :32: "ALIOTH"           1.7 166.77  56.10 }
   { :33: "SPICA"            1.2 158.47 -10.78 }
   { :34: "ALKAID"           1.9 152.94  49.23 }
   { :35: "HADAR"            0.9 149.47 -60.27 }
   { :36: "MENKENT"          2.3 148.08 -36.01 }
   { :37: "ARCTURUS"         0.2 145.89  19.09 }
   { :38: "RIGEL KENTAURUS"  0.1 139.81 -60.53 }
   { :39: "ZUBENELGENUBI"    2.9 137.62 -15.95 }
   { :40: "KOCHAB"           2.2 137.34  74.08 }
   { :41: "ALPHECCA"         2.3 126.14  26.66 }
   { :42: "ANTARES"          1.2 112.38 -26.27 }
   { :43: "ATRIA"            1.9 107.37 -68.89 }
   { :44: "SABIK"            2.6 102.75 -15.70 }
   { :45: "SHAULA"           1.7  97.00 -37.08 }
   { :46: "RASALHAGUE"       2.1  96.06  12.55 }
   { :47: "ELTANIN"          2.4  90.98  51.50 }
   { :48: "KAUS AUSTRALIS"   2.0  84.35 -34.40 }
   { :49: "VEGA"             0.1  80.62  38.80 }
   { :50: "NUNKI"            2.1  75.91 -26.39 }
   { :51: "ALTAIR"           0.9  62.09   8.91 }
   { :52: "PEACOCK"          2.1  53.25 -56.97 }
   { :53: "DENEB"            1.3  49.49  45.35 }
   { :54: "ENIF"             2.5  33.74   9.96 }
   { :55: "AL NA'IR"         2.2  28.32 -47.08 }
   { :56: "FOMALHAUT"        1.3  15.34 -30.01 }
   { :57: "MARKAB"           2.6  14.12  15.07 }
}
//
/Var astro
{
   MAIN   FIND  SDISP   STAR\Gh TIM\Gh SPLOT
   \->UV2 XY\-> R\Gh\-> \->UV3  XYZ\-> R\Ghp\->
   HPJD   JULIAN
}
//
/Var \GSPAR
{ 1 2 1.97872340426 -.63829787234 LINFIT }
//
/Var CST
astro
//
/Var EQ
'1.97872340426+-.63829787234*X'
