// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var dsp
@ nondestructive display row column flag
\<<
   DUP2 RC\->F flg
\>>
//
/Var dsp0
@ toggle flag display
\<<
   RC\->F 1 CF flg
\>>
//
/Var dsp1
@ toggle flag display
\<<
   RC\->F 1 SF flg 1 CF
\>>
//
/Var F\->RC
@ flag to row column 0 based
\<<
   ABS
   \-> f
   \<<
      f 1 - 8 MOD f 1 - 8 / IP
   \>>
\>>
//
/Var flg
@ display flag
\<<
   DUP SIGN ABS "\[]"
   \-> f s t
   \<<
      f 2 PAD0 2 3 SUB
      IF
         f FS?
      THEN
         t
      ELSE
         " "
      END
      +
      1
      f F\->RC SWAP 3 + SWAP 4 * 1 +
      GDISP
   \>>
\>>
//
/Var FLG
@ graphical display of flags
@ flags: 1,2,3,5, & 64 are used by this APP
@ DO NOT CHANGE THEM DRUING OPERATION
\<<
   # 83h # 40h PDIM
   { # 0h # 0h } PVIEW
   1 CF 2 CF 3 CF
   IF                                  @ title
      5 FS?
   THEN
      "User"
   ELSE
      "System"
   END
   " Flags" +
   2 1 1 GDISP
   1 64                                @ display flags
   FOR f f
      IF
         5 FC?
      THEN
         NEG
      END
      flg
   NEXT
   key
\>>
//
/Var key
@ get key & display flag status
\<<
   64 CF
   0 0
   DUP2 dsp1
   DO
      0 WAIT
      \-> r c k
      \<<
         CASE
            k 25.1 ==
            THEN
               r c dsp0
               'r' DECR c DUP2 dsp1
            END
            k 34.1 ==
            THEN
               r c dsp0
               r 'c' DECR DUP2 dsp1
            END
            k 35.1 ==
            THEN
               r c dsp0
               'r' INCR c DUP2 dsp1
            END
            k 36.1 ==
            THEN
               r c dsp0
               r 'c' INCR DUP2 dsp1
            END
            k 25.3 ==
            THEN
               r c dsp0
               0 c DUP2 dsp1
            END
            k 34.3 ==
            THEN
               r c dsp0
               r 0 DUP2 dsp1
            END
            k 35.3 ==
            THEN
               r c dsp0
               7 c DUP2 dsp1
            END
            k 36.3 ==
            THEN
               r c dsp0
               r 7 DUP2 dsp1
            END
            k 55.1 ==
            THEN
               64 SF
               r c
            END
            k 52.1 == k 51.1 == OR
            THEN
               r c RC\->F
               IF
                  DUP FC?C
               THEN
                  SF
               ELSE
                  DROP
               END
               r c DUP2 dsp1
            END
            r c
         END
      \>>
   UNTIL
      64 FS?
   END
   DROP2
\>>
//
/Var RC\->F
@ row & column to flag
\<<
   \-> r c
   \<<
      r c 8 * + 1 +
      IF
         5 FC?
      THEN
         NEG
      END
   \>>
\>>

