// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN MISC }
/AutoExec
//
/Var \->\->NOTES
@ notes

@ \>>\>>\>> installed \<<\<<\<<

@  %\->\GW
@      FRC
@      PAY SSD pay distribution
@     PAY1
@     PAY2
@      pay 100, 50, 20
@    R\->%
@     SURV
@     rcol
@      rnd
@     rnum
@  \GW\->C

@      CST
@     misc

@ \>>\>>\>> not installed \<<\<<\<<

@    CRYPT en/de/crypt string
@    crypt display for CRYOT
@   dosubs DOSUBS example
@       EQ equation
@   ERRGEN error msg list generator
@   ERRMSG error message list 1024 at a time
@   erridx
@   errmsg
@     FUNC wave forms
@     func equations
@   \GSdat statistics data
@   \GSPAR statistics parameters
@    input test AINFORM & AINPUT in HOME dir
@    ldisp logic table display
@    LOGIC graphic display of truth tables for various functions
@    logic matrix
@ minehunt utility to start MINEHUNT
@     misc custom menu
@ M\<-\->L bidirectional matirx/list conversion
@  Nmines # mines for game
@  nshift shift digits by n
@  nSHIFT shift digits thru all #'s
@   PERSO display 'perso' string
@   perso encrypted personal information string
@     PLT graph of waveforms & derivatives
@     plt equations
@    PPAR plot parameters
@   PRIME test for prims if not then find next
@         5 CF = up
@         5 SF = dn
@   prime find prime either side of given, does not test given
@     PYR payment type for TVM
@    rjst test of RJST prgm variations
@    TRIG basic trig functions
@         saw0 1 = function wave
@         saw1
@         sqr0
@         sqr1
@         tri0 different waveforms for WAVDLX
@         tri1 0 = pure wave
@         trig
@  TRIWAV true triangle wave
@  triwav
@  WAVDLX waveform deluxe
@    ZPAR 3D plot parameters
//
/Var %\->\GW
@ ?
\<<
   5 / rnum SIZE
   \-> n z
   \<<
      IF
         n 1 >
      THEN
         1 z
         FOR i
            'rnum' i GET
         n STEP
         z n / \->LIST ELSE rnum
      END
   \>>
\>>
//
/Var \GW\->C
@ ?
\<<
   MANT LASTARG XPON SWAP IP LASTARG FP 10 *
   \-> c a b
   \<<
      'rcol' a 1 + GET 'rcol' b 1 + GET 'rcol'
      IF
         c 1 <
      THEN
         c ABS 11 +
      ELSE
         c
      END
      GET 3 \->LIST a 10 * b + c 1 - 10 / + \->TAG
   \>>
\>>
//
/Var CRYPT
@ en/de/crypt string / list of strings
@ simple random # chr offset
@ when display flags are not used a list is left on the stack
@ flag:  none  continue en/de/crypt
@ 5     en/de/crypt
@ 6     initialize random #
@ 7     display string
@ 8     graphic display
\<<
   IF                                  @ clear display
      8 FS?
   THEN
      # 83h # 40h PDIM
      {# 0h # 0h} PVIEW
   ELSE
      CLLCD
   END
   IF                                  @ initialize random #
      6 FS?C
   THEN
      RDZ
   END
   IF
      DUP TYPE 2 ==
   THEN                                @ parse string
      PARSE
   END
   IF                                  @ status display
      7 FC?
   THEN
      DUP SIZE 2 DISP
   END
   1
   DO
      \-> l r
      \<<
         l r GET                       @ get string
         r 1 crypt                     @ display
         1 OVER SIZE
         IF                            @ status display
            7 FC?
         THEN                          @ status #
            r 1 DISP
            DUP 5 DISP
         END
         FOR c
            DUP c DUP SUB              @ get chr to en/de/crypt
            IF                         @ check for space & return
               DUP " " \=/ OVER " " \=/ AND
            THEN
               NUM                     @ get chr #
               RAND 129 * IP           @ get random #
               IF
                  5 FS?
               THEN                    @ decrypt
                  -
               ELSE                    @ encrypt
                  +
               END
               256 MOD                 @ wrap #
               CHR                     @ chr
            END
            c SWAP REPL                @ insert chr in str
            r c crypt                  @ display
         NEXT
         l r ROT PUTI                  @ put str in list
      \>>
   UNTIL
      -64 FS?
   END
   DROP
   CASE
      7 FS?
      THEN
         DROP
         3 FREEZE
      END
      8 FS?
      THEN
         DROP
         {} PVIEW
      END
   END
\>>
//
/Var crypt
@ CRYPT display
\<<
   \-> r c
   \<<
      CASE
         7 FS?
         THEN                          @ display string
            DUP r DISP
         END
         8 FS?
         THEN                          @ graphic display
            DUP 2 r 1 GDISP
         END
         c 4 DISP                      @ display status #
      END
   \>>
\>>
//
/Var CST
'misc'
//
/Var dosubs
@ DOSUBS example
@ see also: nshift
@ this subdivides a list by n
@ ENDSUB = SIZE - n + 1; number of sub-lists
\<<
   CLLCD
   { 4 4 9 1 5 9 0 6 8 }               @ sub-lists = 7
   3
   \-> n
   \<<
      n
      \<<
         IF NSUB 1 - n MOD 0 ==        @ n modulus
         THEN                          @ make sub-list
            n \->LIST
         ELSE                          @ delete unwanted sub-list
            n DROPN
         END
      \>>
      DOSUBS
   \>>
\>>
//
/Var EQ
'SIGN(COS(X))*(2/\pi*X-2*IP((2/\pi*X+SIGN(2/\pi*X))/2))'
//
/Var ERRGEN
@ ERRMSG utility
@ uses: ERRMSG, AVAIL, BEEP3
\<<
   DO
      880 .02 BEEP ERRMSG
   UNTIL
      errmsg SIZE 0 \=/
   END
   AVAIL -9 BEEP3
\>>
//
/Var erridx
@ starting error message index
# B800h
//
/Var ERRMSG
@ error message list generator
\<<
   CLLCD erridx B\->R DUP 255 +
   FOR err
      IFERR err DOERR
      THEN
         ERRN 3 DISP
         IF ERRM "" \=/
         THEN
            ERRM 4 DISP ERRN ERRM 2 \->LIST
         END
      END
   NEXT
   DEPTH \->LIST 'errmsg' SWAP STO+
   'erridx' # 100h STO+
\>>
//
/Var errmsg
@ error message list
{ }
//
/Var FRC
@ ?
\<<
   RCLF
   \-> f
   \<<
      CLLCD ERASE VIEW0
      1 10 FOR n
         n 4 + 16 / \->Q DUP \->NUM
         '1 _in' \->UNIT DUP '1_mm' CONVERT
         0 RND
         DUP2 SWAP - 4 RND
         3 0 FOR c
            IF
               c ODD
            THEN
               4 FIX
            ELSE
               STD
            END
            1 n c 8 * c 3 == 5 PICK \->NUM UVAL
            0 \>= AND + c 2 == DUP 6 PICK \->NUM UVAL
            10 < AND + + GDISP
         -1 STEP
      NEXT
      VIEW7
      f STOF
   \>>
\>>
//
/Var FUNC
@ various wave forms
@ uses: func
\<<
   # 83h # 40h PDIM
   RAD
   1 .4 SCALE
   (6.3,0) CENTR
   # 0h RES
   -28 CF -31 CF
   { # 0h # 0h } PVIEW
   'func' 1
   DO
      GETI STEQ ERASE DRAX DRAW PICT RCL ROT ROT 3 WAIT
   UNTIL
      -64 FS?
   END
   ERASE DROP2
   { # 0h # 0h } SWAP GOR
   { # 0h # 0h } SWAP GOR
   PICT STO
   { } PVIEW
\>>
//
/Var func
@ USED BY: func
{
   'SIN(X)'                            @ sine
   'SIN(X+1*SIN(1*X))'                 @ saw
   'SIN(X+1*SIN(2*X))'                 @ square
}
//
/Var input
@ test of automatic input prgms
\<<
   "Automatic INFORM" 1 { A B C } AINFORM
   "Automatic INPUT"    { A B C } AINPUT
\>>
//
/Var ldisp
@ display truth table
@ used bu: LOGIC
\<<
   1
   \-> ro co s
   \<<
      s 1 ro + 1 co + GDISP 1 3
      FOR r
         1 3
         FOR c
            IF r 1 == c 1 == AND NOT
         THEN
            'logic' r c 2 \->LIST GET
            s r ro + 1 + c co + 1 + GDISP
         END
         NEXT
      NEXT
   \>>
\>>
//
/Var LOGIC
@ graphical display of truth tables
\<<
   1 8 RCLF
   \-> r c f
   \<<
      STD
      # 83h # 40h PDIM
      { # 0h # 0h } PVIEW
      1 6
      FOR n
         2 3
         FOR r
            2 3
            FOR c
               'logic' r c 2 \->LIST
               'logic' r 1 2 \->LIST
               GET 'logic' c 1 2 \->LIST GET
               CASE
                  n 1 ==
                  THEN
                     AND               @ and
                  END
                  n 2 ==
                  THEN
                     OR                @ or
                  END
                  n 3 ==
                  THEN
                     XOR               @ xor
                  END
                  n 4 ==
                  THEN
                     AND NOT           @ nand
                  END
                  n 5 ==
                  THEN
                     OR NOT            @ nor
                  END
                  n 6 ==
                  THEN
                     XOR NOT           @ nxor
                  END
               END
               PUT
            NEXT
         NEXT
         CASE
            n 1 ==
            THEN
               " AND" 0 r + 0 c +
            END
            n 2 ==
            THEN
               "  OR" 0 r + 5 c +
            END
            n 3 ==
            THEN
               " XOR" 0 r + 10 c +
            END
            n 4 ==
            THEN
               "NAND" 5 r + 0 c +
            END n 5 ==
            THEN
               " NOR" 5 r + 5 c +
            END n 6 ==
            THEN
               "NXOR" 5 r + 10 c +
            END
         END
         ldisp
      NEXT
      { } PVIEW
      f STOF
   \>>
\>>
//
/Var logic
@ LOGIC matrix
[[ 0 0 1 ]
 [ 0 1 0 ]
 [ 1 0 1 ]]
//
/Var M\<-\->L
@ bidriectional matrix/list converter
\<<
   RCLF
   \-> f
   \<<  -55 CF
      \->STR                           @ make string
      LASTARG
      TYPE                             @ get type
      \-> t
      \<<
         "[" "{"
         IF t 5 ==                     @ list ?
         THEN
            SWAP
         END
         \-> s r
         \<<
            1 2
            START                      @ find & replace mat/lst chr
               WHILE DUP s POS DUP
               REPEAT
                  r REPL
               END
               DROP
               "]" "}"
               IF t 5 ==               @ list ?
               THEN
                  SWAP
               END
               'r' STO 's' STO
            NEXT
            OBJ\->                     @ make object
         \>>
      \>>
      f STOF
   \>>
\>>
//
/Var minehunt
@ starts the MINEHUNT game
@ asks for # of mines
\<<
   "# Of Mines\010visable = -#\010best score = 16"
   { ":Nmines:20" -9 V } INPUT
   OBJ\-> sto
   MINEHUNT
\>>
//
/Var misc
{ MAIN SURV PAY VIEW3 VIEW7 }
//
/Var nSHIFT
@ graphic display of shifted digits thru all #'s
@ uses: nshift
\<<
   4
   \-> n c
   \<<
      # 83h # 40h PDIM { # 0h # 0h } PVIEW
      0 9
      FOR
         i n i nshift 1 i 1 + .5 + c GDISP
      NEXT
      { } PVIEW
   \>>
\>>
//
/Var nshift
@ shift each digit by n
@ first ever use of DOSUBS, never thought it much use
\<<
   RCLF
   \-> n f
   \<<
      -55 CF
      MANT LASTARG XPON
      \-> m x
      \<<
         m 1 x                         @ break apart digits
         START
            IP LASTARG FP 10 *
         NEXT
         x 1 + \->LIST make digit list
      \>>
      1 \<< n + \>> DOSUBS 10 MOD      @ shift
      f STOF
   \>>
\>>
//
/Var pay
{ 100 50 20 }
//
/Var PAY
@ ?
\<<
   RCLF
   \-> f
   \<<
      CLLCD ERASE STD
      "PROCESSING" 1 DISP
      DUP PAY1 SWAP
      " PAY" \->TAG
      3 1 1 VIEW0 GDISP
      1
      \<<
         3 NSUB 1 + 1 GDISP
      \>>
      DOSUBS
      VIEW7
      IF
         21 FS?
      THEN
         PRLCD
      END
      f STOF
   \>>
\>>
//
/Var PAY1
@ ?
\<<
   pay "E" +
   \-> t l
   \<<
      t 2 PAY2 t 0 PAY2 t 1 PAY2 3
      \<<
         3
         \->LIST
      \>>
         DOLIST 1
      \<<
         "" SWAP 1
         \<<
            4 RJST +
         \>>
         DOSUBS
         'l' NSUB GET 4 RJST
         \->TAG
      \>>
      DOSUBS
   \>>
\>>
//
/Var PAY2
@ ?
\<<
   pay
   \-> t r l
   \<<
      l 1
      \<<
         t l
         IFERR
            \GSLIST
         THEN
            1 GET
         END
         IFERR
            /
         THEN
            DROP2 0
         END
         r rnd
         \-> q n
         \<<
            t q n * - 't' STO n
         \>>
         l TAIL 'l' STO
      \>>
      DOSUBS
      t +
   \>>
\>>
//
/Var perso
@ encrypted 'perso~' string using code 5247
C$ 160 \165\160\>=\165\206zn\Gw\189  \163  ]q\186\209\192\200}\->
ZW|\<-p\127\Gg9N\|^ \193\<<\O/\199\GgZ\205\172\232\185l
e}\=/\GgQ\GS\[]Q\Gw\174w   y\182\<<v\227\Ge\178,
q\170\GlO~T\Gds\175N\.VU   \220\Gl\230 \175\Gt\221
q}|]\Gn\.V\163j\162]\165\178   \214o\168 \217\Ga\233
\162\161M" h _b\169\221 \>=\^o      \x-\GD
\->\Gg\.S\[]\Gg\173j~\v/\>>o \177\184   \GegbS\=/
//
/Var PERSO
@ decrypt personal information list
@ displays decryption on screen
\<<
   CLUFL                               @ clear user flags
   5 SF 6 SF 7 SF 8 CF                 @ set 'CRYPT' flags
   perso SWAP CRYPT                    @ decrypt
   CLUFL                               @ clear user flags
\>>
//
/Var perso~
@ personal info string
"Elizabeth  K  Thompson
27.10.1956 alrgy:Sulfa
449-15-9068   blood:A+
812-560-8398   vir mbl
765-398-0466   con cel
207\189 E Main St      #4
Greensburg, IN   47240"
//
/Var PHONE
@ phone mneumonic decoder
@ modified from original EduCalc Challenge for 10 digits
\<<
   0                                   @ output #
   1 10 FOR j
      10 *                             @ shift output
      " QZ1ABC2DEF3GHI4JKL5MNO6PRS7TUV8WXY9"  @ letters & #'s table
      3 PICK                           @ get input string; leaves str on stk
      j DUP SUB                        @ get 'j' character
      POS 4 / CEIL                     @ find input in decode str & round up
      +                                @ build output
   NEXT
   SWAP DROP 10000000 /                @ shift
\>>
//
/Var PLT
@ graph of various functions & their derivatives
\<<
   CLLCD 3
   \-> c
   \<<
      RCLF
      RAD STD .5 .5 SCALE (3.15,0) CENTR # 3h RES -28 CF -31 CF
      ERASE DRAX "SAW" 1 1 c GDISP 1 'A' STO 1 'B' STO
      plt EVAL DUP 'X' \.d 2 / 2 \->LIST STEQ DRAW
      5 SF 0 WAIT DROP
      ERASE DRAX "SQUARE" 1 1 c GDISP 2 'B' STO
      plt EVAL DUP 'X' \.d 2 / 2 \->LIST STEQ DRAW
      5 SF 0 WAIT DROP
      STOF
   \>>
\>>
//
/Var plt
@ PLT equation
'SIN(X+(A*SIN(B*X)))'
//
/Var prime
@ find prime on either side of given & determine if given is prime
\<<
   RCLF
   \-> n f
   \<<
      5 CF n PRIME
      \-> p
      \<<
         IF n p ==
         THEN                          @ prime
            5 SF n 2 - PRIME
            n "prime" \->TAG
            5 CF n 2 + PRIME
         ELSE                          @ normal
            5 SF n PRIME
            n "norm" \->TAG
            p
         END
      \>>
      f STOF
   \>>
\>>
//
/Var PRIME
@ find next prime if not already prime
@ used by: prime
@ only tests odd #
@ used by: prime
@ removing the text display saves
@ #       s
@ 100    0.2
@ 500    0.5
@ 1000    1.9
@ 3907    1.5
@ 5000    1.6
@ 5247    4.2
@ 10000    4.1
@ overall the time saved increases with the # with variation
@ I like the text display of the process
\<<
   CLLCD 3 1
   \-> p d f
   \<<
      IF p EVEN                        @ make odd
      THEN 'p' 1
         IF 5 FS?                      @ direction
         THEN
            STO-
         ELSE
            STO+
         END
      END
      p d / FP 0 == 'f' STO            @ set divisable flag
      WHILE                            @ find prime
         f d p \v/ < OR                @ found prime or reached limit
      REPEAT
         p 4 DISP                      @ current #
         d 5 DISP                      @ current divisor
         IF f                          @ if divisable
         THEN
            'p' 2                      @ increment #
            IF 5 FS?                   @ direction
            THEN
               STO-
            ELSE
               STO+
            END
            3 'd' STO                  @ reset divisor
         ELSE
            'd' 2 STO+                 @ increment divisor
         END
         p d / FP 0 == 'f' STO         @ set divisable flag
      END
      p                                @ return prime
   \>>
\>>
//
/Var PYR
12
//
/Var R\->%
@ ?
\<<
   0
   \-> q p x
   \<<
      CASE
         p 5 == p 10 == OR p 20 == OR
         THEN
            p // /Var %\->\GW
         END
         q p "Error: %" DOERR
      END
         100 + 1 q XPON 1 - 'x' STO q MANT 10 * 'q' STO
         DO
            \-> i
            \<<
               i GETI
               \-> n
               \<<
                  IF
                     q n \<=
                  THEN
                     DROP2 n -64 SF
                  END
               \>>
            \>>
         UNTIL
            -64 FS?
         END
         x ALOG *
   \>>
\>>
//
/Var rcol
{ "BK" "BR" "RD" "OR" "YL" "GR" "BL" "VI" "GY" "WT" "GD" "SL" "NO" }
//
/Var rjst
@ test of RJST & its' variations
\<<
   CLLCD "TEST" 22
   \-> s n
   \<<
      s n RJST 1 DISP
      1 6
      FOR f
         f SF s n RJST f 1 + DISP
      NEXT
   \>>
   3 FREEZE
\>>
//
/Var rnd
@ ?
\<<
   \-> q
   \<<
   CASE
      q 1 ==
      THEN
         FLOOR
      END
      q 2 ==
      THEN
         CEIL
      END
      0 RND
   END
   \>>
\>>
//
/Var rnum
{
   10 11 12 13 15 16
   18 20 22 24 27 30
   33 36 39 43 47 51
   56 62 68 75 82 91
}
//
/Var SURV
@ ?
\<<
   90 SWAP - 360 MOD
\>>
//
/Var TMP
@ ?
\<<
   \-> r
   \<<
      r 5 R\->% \GW\->C
      r 10 R\->% \GW\->C
      r 20 R\->% \GW\->C
   \>>
\>>
