// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN PLOT CALC }
/AutoExec
//
/Var \->\->NOTES
@ calculus

@ > > > programs
@   I.EQ integrate EQ & plot
@ PEQ.E2 make EQ from poloynomial vector
@   i.eq plotting EQ program

@ > > > misc
@ A B C IERR   integration variables
@ calc         custom menu
//
/Var calc
@ calc menu
{
   PLOT view   EQ   PEQ.E2 I.EQ  IERR
   A    B      C    centr  scale atick
   pdim PRPICT UTIL
}
//
/Var i.eq
@ EQ program
\<<
   eq EVAL                             @ get original EQ Y
   \-> Y
   \<<
      IF X A \>= X B \<= AND
      THEN
         X 0 R\->C X Y R\->C LINE      @ shade in integration range
      END
      Y
   \>>
\>>
//
/Var I.EQ
@ integrate EQ & plot
\<<
   CLLCD RCLF
   \-> f
   \<<
      "Integrating EQ" 4 DISP
      ERASE DRAX                       @ prepare plot
      'B' STO 'A' STO                  @ save inputs
      0 'IERR' STO                     @ clear error
      A B EQ 'PPAR' 3 GET \.S          @ integrate
      \->NUM 'C' STO                   @ save result
      EQ 'eq' STO                      @ save EQ
      'i.eq' STEQ                      @ save EQ prgm
      DRAW                             @ draw integration
      eq STEQ 'eq' PURGE               @ restore original EQ
      { EQ IERR A B C }                @ display results on graph
      1
      \<<
         \-> v
         \<<
            IF v 'IERR' SAME
            THEN
            3 ENG
            END
            v rcl 1 NSUB 1 GDISP f STOF
         \>>
      \>>
      DOSUBS
   \>>
   7 FREEZE
   IF 21 FS?
   THEN
      PRPICT
   END
\>>
//
/Var PEQ.E2
@ make EQ from polynomial vector
\<<
   0 SWAP                              @ start of EQ
   OBJ\-> OBJ\-> DROP \->LIST          @ convert array to list
   1
   \<<
      X ENDSUB NSUB - ^ * +            @ build EQ
   \>>
   DOSUBS
   STEQ                                @ save EQ
\>>
