// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ Triangle Solutions
@ unlike previous versions of this prgm equations were used instead of RPN

@ AAS ASA ASS SAS SSS

@ disp display variables
@  PIC graphical title screen

@ FLAG
@ CON: -2 constant \-> symb / num
@ FUN: -3 function \-> symb / num
@ FRM:  5 INPUT / INFORM

@     tri custom menu
@   input newer
@ input~o older stand alone
//
/Var \->str
@ convert variable to string
@ uses: rcl
\<<
   rcl \->STR 10 CHR +
\>>
//
/Var \Gg
90
//
/Var \Ga
30
//
/Var \Gb
60
//
/Var A
.866025403773
//
/Var a
1
//
/Var AAS
@ uses: input, rnd, & disp
\<<
   "AAS" '\Ga' '\Gb' 'a' input
   '180-(\Ga+\Gb)'          \->NUM '\Gg' STO
   'a/SIN (\Ga)*SIN(\Gb)'   \->NUM 'b'   STO
   'a/SIN(\Ga)* SIN(\Gg)' \->NUM 'c'   STO
   disp
\>>
//
/Var ASA
@ uses: input, rnd, & disp
\<<
   "ASA" '\Ga' 'c' '\Gb' input
   '180-(\Ga+\Gb)'          \->NUM '\Gg' STO
   'c/SIN (\Gg)*SIN(\Ga)' \->NUM 'a'   STO
   'c/SIN(\Gg)* SIN(\Gb)' \->NUM 'b'   STO
   disp
\>>
//
/Var ASS
@ uses: input, rnd, & disp
\<<
   "ASS" '\Ga' 'a' 'b' input
   'ASIN(SIN(\Ga)/ a*b)'  \->NUM '\Gb'   STO
   '180-(\Ga+\Gb)'          \->NUM '\Gg' STO
   'b/SIN(\Gb)* SIN(\Gg)' \->NUM 'c'   STO
   disp
\>>
//
/Var b
'\v/3'
//
/Var c
2
//
/Var CST
'tri'
//
/Var disp
@ correct 0.0000000001 rounding error
@           123456789<
@ ignores symbolic variables
@ also calculates area
\<<
   { a b c \Ga \Gb \Gg A }
   \-> l
   \<<
   CLLCD
   l 1                                 @ round data
   DO
      GETI \-> v
      \<<
         IF
            v VTYPE 0 ==
         THEN
            v RCL 9 RND v STO
         END
      \>>
   UNTIL
      -64 FS?
   END
   DROP2
                                       @ calc area using 's'
                                       @ '(a+b+c)/2' \->NUM 's' STO
                                       @ '\v/(s*(s-a)*(s-b)*(s-c))' \->NUM 'A' STO
                                       @ calc area using base & height
   'a*c*SIN(\Gb)/2' \->NUM 'A' STO
   l LDISP                             @ display data
   \>>
\>>
//
/Var FLAG
@ modified version of the HOME FLAG prgm
@ given: string, flag #, & list position
@ builds TMENU string
\<<
   "CON" -2 1 flgstr
   "FUN" -3 2 flgstr
   "FRM"  5 3 flgstr
   3 \->LIST 'flgmnu' STO
   flgmnu TMENU
\>>
//
/Var flgmnu
{
   { "CON" \<< -2 1 flag \>> }         @ const \-> symb
   { "FUN" \<< -3 2 flag \>> }         @ func \-> symb
   { "FRM" \<<  5 3 flag \>> }         @ input/inform
}
//
/Var h
@ triangle height
.866025403785
//
/Var input
@ input using AINPUT / AINFORM
@ uses: AINPUT, AINFORM
\<<
   CLLCD
   3 \->LIST
   SWAP
   "TRI:" SWAP +
   SWAP
   IF
      5 FS?
   THEN
      1 SWAP AINFORM
   ELSE
      AINPUT
   END
\>>
//
/Var input~o
@ INPUT or INFORM input
@ WARNING! the 48SX only has INPUT
@ uses: \->str
@ older stand alone version of 'input'
\<<
   CLLCD
   \-> s a b c
   \<<
      IF
         5 FC?
      THEN                             @ INPUT
         RCLMNU
         "TRI:" s +
         a \->str
         b \->str +
         c \->str +
         1 OVER SIZE 1 - SUB
         { 1 5 } ALG V 4 \->LIST
         28 MENU INPUT
         OBJ\-> sto sto sto
         MENU
      ELSE                             @ INFORM
         "Enter #" { 0 9 }
         \-> t v
         \<<
            DO
               "TRI:" s +
               a \->STR t 2 \->LIST v +
               b \->STR t 2 \->LIST v +
               c \->STR t 2 \->LIST v +
               3 \->LIST
               { 1 1 }
               a RCL b RCL c RCL
               3 \->LIST DUP INFORM
            UNTIL 1 ==
            END
            OBJ\-> DROP c STO b STO a STO
         \>>
      END
   \>>
\>>
//
/Var PIC
@ graphical title / help screen for triangle solutions
\<<
   1.01 MENU                           @ CST menu
@- - - - - - - - - - - - - - - - - - - - initialize graphics
   { # 0h # 0h } PVIEW                 @ show graphics
   # 80h # 40h PDIM                    @ reset grqaphics
   -6.5 6.5 XRNG -3.1 3.2 YRNG         @ X & Y ranges
@- - - - - - - - - - - - - - - - - - - - draw triangle
   ( 0, 2) ( 4,-1) LINE
   ( 4,-1) (-4,-1) LINE
   (-4,-1) ( 0, 2) LINE
   ( 0, 2) ( 0,-1) LINE
@- - - - - - - - - - - - - - - - - - - - label triangle size 2
@   "\Ga"   2 1.25 11.5  GDISP
@   "\Gb"   2 6     3.75 GDISP
@   "\Gg" 2 6    19.25 GDISP
@   "a"   2 6.5  11.25 GDISP
@   "b"   2 3.25 15.75 GDISP
@   "c"   2 3.25  7.25 GDISP
@   "h"   2 4.25 12.25 GDISP
@- - - - - - - - - - - - - - - - - - - - label triangle size 3
   "\Ga"   3 1    11.5  GDISP
   "\Gb"   3 5     3.75 GDISP
   "\Gg" 3 5    19.25 GDISP
   "a"   3 5.5  11.25 GDISP
   "b"   3 2.5  15.75 GDISP
   "c"   3 2.5   7.25 GDISP
   "h"   3 3.5  12.25 GDISP
@- - - - - - - - - - - - - - - - - - - - title size 2
@   "Triangle"  2 1  1 GDISP
@   "Solutions" 2 1 14 GDISP
@- - - - - - - - - - - - - - - - - - - - title size 3
   "Triangle"  3 1  1 GDISP
   "Solutions" 3 1 14 GDISP
@- - - - - - - - - - - - - - - - - - - - freeze display above menu
   3 FREEZE
\>>
//
/Var PPAR
@ plot parameters for graphical triangle solutions
{
   (-6.5,-3.1)
   (6.5,3.2)
   X
   0
   (0,0)
   FUNCTION
   Y
}
//
/Var s
2.36602540378
//
/Var SAS
@ uses: input, rnd, & disp
\<<
   "SAS" 'a' '\Gg' 'b' input
   '\v/(a^2+b^2-2* a*b*COS(\Gg))'  \->NUM 'c' STO
   'ASIN(SIN(\Gg )/c*a)'         \->NUM '\Ga' STO
   'ASIN(SIN(\Gg)/c* b)'         \->NUM '\Gb' STO
   disp
\>>
//
/Var SSS
@ uses: input, rnd, & disp
\<<
   "SSS" 'a' 'b' 'c' input
   'ACOS((b^2+c^ 2-a^2)/(2*b*c))' \->NUM '\Ga'   STO
   'ACOS((a^2+c^2-b^2)/(2*a*c))'  \->NUM '\Gb'   STO
   'ACOS((a^2+b^2-c^2)/(2*a*b))'  \->NUM '\Gg' STO
   disp
\>>
//
/Var tri
{ MAIN AAS ASA ASS
SAS SSS disp FLAG
CLKMNU UTIL { } A a
b c \Ga \Gg \Gb }
