// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ conversion stuff

@ M\->HM   minutes to hours & minutes, used for cooking times
@ conv   CST menu

@ units
@ clk mo sht stn tck wk
//
/Var clk
@ alarm clock unit
'12_min'
//
/Var conv
@ conversion menu
{
   MAIN
   {
      "COOK"
      \<<
         {
            '1_gal' '1_qt'  '1_cu' '1_ozfl' '1_tbsp' '1_tsp'
            '1_pt'  '1_sht' '1_l'  '1_h'    '1_min'  { "M\->HM"{ M\->HM } }
         }
         TMENU
      \>>
   }
   {
      "MASS"
      \<<
         { '1_lb' '1_kg' '1_stn' '1_slug' }
         TMENU
      \>>
   }
   {
      "TIME"
      \<<
         {
            '1_yr'  '1_mo' '1_wk' '1_d' '1_h' '1_clk'
            '1_min' '1_s'  '1_tck'
         }
         TMENU
      \>>
   }
   {
      "TMNU"
      {
         \<<
            94 MENU
         \>>
      }
   }
   UTIL
}
//
/Var ftlb
@ foot pounds
'4.21401100938E-2_kg*m^2/s^2'
//
/Var IN\->FT
@ in to ft & in
\<<
   UVAL '1_in' \->UNIT
   DUP '1_ft' CONVERT IP
   SWAP OVER '1_in' CONVERT -
   2 \->LIST
\>>
//
/Var M\->HM
@ convert minutes to hours & minutes
@ used for cooking times
\<<
   '1_h' CONVERT
   IPFP
   '1_min' CONVERT
   9 RND
\>>
//
/Var mo
@ months per year
'8.33333333333E-2_yr'
//
/Var SAIR
@ speed of sound in air
'1116.45_ft/s'
//
/Var sht
@ shot glass
'1.5_ozfl'
//
/Var SSEA
@ speed of sond in salt water
'4945.37_ft/s'
//
/Var stn
@ stone
'14_lb'
//
/Var tck
@ 8192 HP48 ticks per second
'1.220703125E-4_s'
//
/Var TEMP
@ display temp conv chart
\<<
   CLLCD RCLF
   \-> f
   \<<
      STD 1 12
      FOR n
         n 5 * 10 - '1_\^oC' \->UNIT
         DUP O\->S 7 RJST SWAP '1_\^oF' CONVERT
         O\->S 10 RJST +
         IF
            21 FS?
         THEN
            PR1
         END
         n 7 mod DISP
      NEXT
      f STOF
   \>>
   IF
      21 FS?C
   THEN
      EJECT
   END
\>>
//
/Var wk
@ days per week
'7_d'
