// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ NOTES

@    \>>\>>\>> start \<<\<<\<<
@ MATMNU start material prgm
@ matmnu tmenu
@    FLG string

@    \>>\>>\>> Gage \<<\<<\<<
@    GAL aluminum
@    GSS stainless
@    GST steel
@    GIN input
@   GOUT output

@    \>>\>>\>> Thickness \<<\<<\<<
@    TAL aluminum
@    TSS stainless
@    TST steel
@    TIN input
@   TOUT output

@    \>>\>>\>> data & configuration \<<\<<\<<
@    \GSAL table's used for making eq's
@    \GSSS not needed for normal operation
@    \GSST

@    \GSal equation's used in prgm's
@    \GSss
@    \GSst

@    mat custom menu
@     EQ equation
@   \GSPAR statistics
@   \GSDAT statistics sata
@  \GSPLOT plot current statistics model & equation
//
/Var \GSAL
@ aluminum data
[[  5 .1819 ]
 [  6 .1620 ]
 [  7 .1443 ]
 [  8 .1285 ]
 [  9 .1144 ]
 [ 10 .1019 ]
 [ 11 .0907 ]
 [ 12 .0808 ]
 [ 13 .0720 ]
 [ 14 .0641 ]
 [ 15 .0571 ]
 [ 16 .0508 ]
 [ 17 .0453 ]
 [ 18 .0403 ]
 [ 19 .0359 ]
 [ 20 .0320 ]
 [ 21 .0285 ]
 [ 22 .0253 ]
 [ 23 .0226 ]
 [ 24 .0201 ]
 [ 25 .0179 ]
 [ 26 .0159 ]
 [ 27 .0142 ]
 [ 28 .0126 ]
 [ 29 .0113 ]
 [ 30 .0100 ]
 [ 31 .0089 ]
 [ 32 .0080 ]
 [ 33 .0071 ]
 [ 34 .0063 ]
 [ 35 .0056 ]
 [ 36 .0050 ]
 [ 37 .0045 ]]
//
/Var \GSal
@ aluminum equation
'T=.324598591266*EXP(-(.115887672218*G))'
//
/Var \GSDAT
@ statistics
\GSST
//
/Var \GSPAR
@ statistics
{
   1 2 .377578698852 -.113748907188 EXPFIT
}
//
/Var \GSPLOT
@ statistics plot
\<<
   4 \-> c
   \<<
      # 83h # 40h PDIM
      { # 0h # 0h } PVIEW
      3 .1 SCALE
      (18,.2) CENTR
      ERASE DRAX
      '\GSDAT' RCL 1 1 c GDISP
      EQ 1 2 c GDISP
      CORR "R" \->TAG 1 3 c GDISP
      SCATTER DRAW
      FUNCTION DRAW
      { } PVIEW
   \>>
\>>
//
/Var \GSSS
@ stainless data
[[  3 .2500 ]
 [  7 .1875 ]
 [  8 .1650 ]
 [ 10 .1350 ]
 [ 11 .1200 ]
 [ 12 .1054 ]
 [ 13 .0937 ]
 [ 14 .0751 ]
 [ 15 .0703 ]
 [ 16 .0595 ]
 [ 17 .0562 ]
 [ 18 .0500 ]
 [ 19 .0437 ]
 [ 20 .0375 ]
 [ 21 .0343 ]
 [ 22 .0312 ]
 [ 23 .0281 ]
 [ 24 .0250 ]
 [ 25 .0218 ]
 [ 26 .0187 ]
 [ 27 .0171 ]
 [ 28 .0156 ]
 [ 29 .0140 ]
 [ 30 .0125 ]]
//
/Var \GSss
@ stainless equation
'T=.406474145657*EXP(-(.116750456723*G))'
//
/Var \GSST
@ steel data
[[  3 .2391 ]
 [  4 .2242 ]
 [  5 .2092 ]
 [  6 .1943 ]
 [  7 .1793 ]
 [  8 .1644 ]
 [  9 .1495 ]
 [ 10 .1345 ]
 [ 11 .1196 ]
 [ 12 .1046 ]
 [ 13 .0897 ]
 [ 14 .0747 ]
 [ 15 .0673 ]
 [ 16 .0598 ]
 [ 17 .0538 ]
 [ 18 .0478 ]
 [ 19 .0418 ]
 [ 20 .0359 ]
 [ 21 .0329 ]
 [ 22 .0299 ]
 [ 23 .0269 ]
 [ 24 .0239 ]
 [ 25 .0209 ]
 [ 26 .0189 ]
 [ 27 .0164 ]
 [ 28 .0149 ]
 [ 29 .0135 ]
 [ 30 .0123 ]
 [ 31 .0105 ]
 [ 32 .0097 ]
 [ 33 .0090 ]
 [ 34 .0082 ]
 [ 35 .0075 ]
 [ 36 .0067 ]
 [ 37 .0064 ]]
//
/Var \GSst
@ steel equation
'T=.377578698852*EXP(-(.113748907188*G))'
//
/Var CST
'mat'
//
/Var EQ
@ equation
\GSst
//
/Var FLG
@ flag string selection
\<<
   CASE
      1 FS?C
      THEN
         "Aluminum"
      END
      2 FS?C
      THEN
         "Stainless"
      END
      3 FS?C
      THEN
         "Steel"
      END
   END
\>>
//
/Var G
@ gage
14
//
/Var GAL
@ aluminum gage
\<<
   1 SF GIN \GSal 'T' .07 ROOT GOUT
\>>
//
/Var GIN
@ gage input
\<<
   FLG " Gage" + ":G:" G + { -1 4 } V 3 \->LIST
   28 MENU
   INPUT
   OBJ\-> sto
   0 MENU
\>>
//
/Var GOUT
@ gage output
\<<
   RCLF \-> f
   \<<
      G STD \->STR f STOF \->TAG MAT
   \>>
\>>
//
/Var GSS
@ stainless gage
\<<
   2 SF GIN \GSss 'T' .07 ROOT GOUT
\>>
//
/Var GST
@ steel gage
\<<
   3 SF GIN \GSst 'T' .07 ROOT GOUT
\>>
//
/Var mat
{ MAIN MATMNU
CLKMNU UTIL }
//
/Var MATMNU
@ material gage & thickness start
\<<
   1 CF 2 CF 3 CF matmnu TMENU
\>>
//
/Var matmnu
@ materail tmenu data
{
   { "G-AL" GAL } { "G-SS" GSS } { "G-ST" GST }
   { "T-AL" TAL } { "T-SS" TSS } { "T-ST" TST }
}
//
/Var T
@ thickness
7.68068877297E-2
//
/Var TAL
@ aluminum thickness
\<<
   1 SF TIN \GSal 'G' 20 ROOT TOUT
\>>
//
/Var TIN
@ thickness input
\<<
   FLG "Thickness" + ":T:" T + { -1 4 } V 3 \->LIST
   28 MENU
   INPUT
   OBJ\-> sto
   0 MENU
\>>
//
/Var TOUT
@ thickness output
\<<
   RCLF \-> f
   \<<
      1 FIX \->STR f STOF T SWAP \->TAG MAT
   \>>
\>>
//
/Var TSS
@ stainless thickness
\<<
   2 SF TIN \GSss 'G' 20 ROOT TOUT
\>>
//
/Var TST
@ steel thickness
\<<
   3 SF TIN \GSst 'G' 20 ROOT TOUT
\>>
