// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN PLOT POLY }
/AutoExec
//
/Var \->\->NOTES
@ polynomial

@ > > > programs
@  EQ\->P convert poly EQ to vector
@  PDER poly vector N derivitive
@ PDRAW poly draw
@   PEQ make poly EQ from poly vector
@  PINT poly vector N integrate
@ RDRAW root draw
@   XFR transfer plot data to CALC directory

@ > > >  misc
@ poly custom menu
//
/Var EQ\->P
@ convert a poly EQ to vector
\<<
   'EQ' RCL
   IF DUP TYPE 5 ==
   THEN
      1 GET
   END
   \->STR DUP "[" POS OVER "]" POS SUB OBJ\->
\>>
//
/Var PDER
@ poly derivative
\<<
   IF OVER SIZE 1 GET OVER >
   THEN 1 SWAP
      START
         DUP SIZE 1 GET
         \-> V Z
         \<<
            1 Z 1 -
            FOR I
               V I GET Z I - *
            NEXT
            Z 1 - \->ARRY
         \>>
      NEXT
   ELSE
      DROP2
   END
\>>
//
/Var PDRAW
@ poly draw
\<<
   CLLCD ERASE DRAX
   DUP SIZE 1 GET
   RCLF
   \-> V Z F
   \<<
      0 Z 2 -
      FOR I
         IF I 0 ==
         THEN
            -31 CF V PEQ DRAW
         ELSE
            -31 SF V I PDER DUP PEQ DRAW RDRAW
         END
         'EQ' RCL
      NEXT
      Z 1 - \->LIST STEQ
      V 1 1 1 GDISP
      F STOF
      7 FREEZE
   \>>
\>>
//
/Var PEQ
@ make EQ from poly vector
\<<
   "\<< " SWAP + " X PEVAL \>>" + OBJ\->
   STEQ
\>>
//
/Var PINT
@ poly vector N integrate
\<<
   1 SWAP
   START
      DUP SIZE 1 GET
      \-> V Z
      \<<
         1 Z
         FOR I
            V I GET Z I - 1 + /
         NEXT
         0 Z 1 + \->ARRY
      \>>
   NEXT
\>>
//
/Var poly
@ poly menu
{
   PLOT  view   EQ    PDRAW PDER  PINT
   PROOT PCOEF  PEVAL centr scale atick
   pdim  PRPICT PEQ   EQ\->P  XFR   UTIL
}
//
/Var RDRAW
@ poly root draw
\<<
   PROOT 1
   DO
      GETI
      \-> N
      \<<
         IF N TYPE 0 ==
         THEN
            N 2 VLINE
         ELSE
            IF N IM 0 ==
            THEN
               N RE 2 VLINE
            END
         END
      \>>
   UNTIL -64 FS?
   END
   DROP2
\>>
//
/Var XFR
@ transfer plot data to CALC
\<<
CLLCD
"Transfer Plot Data

POLY \-> CALC" 1 DISP
   EQ\->P                              @ get poly vector
   { PPAR ZPAR } 5 CF rcl              @ recall vars
   CALC                                @ switch directory
   sto                                 @ save vars
   PEQ.E2                              @ make EQ from poly vector
\>>
