// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ Triangle Solutions
@ rewritten using subroutines much like the original version
@ the EQ version started getting to unwieldy
@ and I kept laughing at ASS instead of SSA

@ various tirangle solutions & variables
@ ASA SAS SAA SSA SSS
@ A a b c \Ga \Gg \Gb h C

@ display
@   disp display variables
@    PIC graphical help screen

@ various solutions used by prgms
@ these take & leave data on the stack
@ abc\->\Gg ab\Gg\->c a\Gab\->\Gb a\Ga\Gb\->b \Ga\Gb\->\Gg

@ solve & store area, centroid, & height using existing variables
@ \->A \->C \->h

@ flag control
@   FLAG
@        CON: -2 constant \-> symb / num
@        FUN: -3 function \-> symb / num
@        FRM:  5 INPUT / INFORM
@ flgmnu TMENU built by 'FLAG'

@ custom menu
@    tri list for 'CST'
@    CST 'tri'

@ miscellaneous
@  input input for tri prgms, uses 'AINPUT'/'AINFORM'
@   PPAR
//
/Var \->A
@ calc area
\<<
   \->h
   b h * 2 /
   \->NUM 'A' STO
\>>
//
/Var \->C
@ calc centroid
@ using intersecting lines y=m1*x+b1 & y=m2*x+b2, b1=0
\<<
   c 2 / b \Ga ab\Gg\->c               @ m1
   \Ga c 2 / a\Gab\->\Gb TAN

   a 2 / b \Gg ab\Gg\->c               @ m2
   \Gg a 2 / a\Gab\->\Gb TAN NEG

    DUP b \->NUM *                     @ b2

   \-> m1 m2 b2
   \<<
      b2 m2 m1 - /
      DUP m1 *
      R\->C
      5 RND
      'C' STO
   \>>
\>>
//
/Var \->h
@ calc height
\<<
   a \Gg SIN * \->NUM 'h' STO
\>>
//
/Var \Gg
@- - - - - - - - - - - - - - - - - - - -
90
//
/Var \Ga
@- - - - - - - - - - - - - - - - - - - -
30
//
/Var \Ga\Gb\->\Gg
@ given two angles find other angle
\<<
   \-> \Ga \Gb
   \<<
      180 \Ga \Gb + - \->NUM
   \>>
\>>
//
/Var \Gb
@- - - - - - - - - - - - - - - - - - - -
60
//
/Var a
@- - - - - - - - - - - - - - - - - - - -
1
//
/Var A
@- - - - - - - - - - - - - - - - - - - -
.866025404
//
/Var a\Ga\Gb\->b
@ given one side & two angles find other side opposite last angle
@ law of sines
\<<
   \-> a \Ga \Gb
   \<<
      a \Ga SIN / \Gb SIN *
      \->NUM
   \>>
\>>
//
/Var a\Gab\->\Gb
@ given two sides & one angle find other angle opposite last side
@ law of sines
\<<
   \-> a \Ga b
   \<<
      b \Ga SIN * a / ASIN
      \->NUM
   \>>
\>>
//
/Var ab\Gg\->c
@ given two sides & one angle find other side opposite angle
@ law of cosines
\<<
   \-> a b \Gg
   \<<
      a SQ b SQ + 2 a * b * \Gg COS * - \v/
      \->NUM
   \>>
\>>
//
/Var abc\->\Gg
@ given three sides find angle opposite last side
@ law of cosines
\<<
   \-> a b c
   \<<
      a SQ b SQ + c SQ - 2 a * b * / ACOS
      \->NUM
   \>>
\>>
//
/Var ASA
@ ASA
@ uses: \Ga\Gb\->\Gg & a\Ga\Gb\->b
\<<
   "ASA" '\Ga' 'c' '\Gb' input

@  var   var   var   fx       var   sto
   \Ga     \Gb           \Ga\Gb\->\Gg   '\Gg' STO
   c     \Gg   \Ga     a\Ga\Gb\->b    'a'   STO
   c     \Gg   \Gb     a\Ga\Gb\->b    'b'   STO

   disp
\>>
//
/Var b
@- - - - - - - - - - - - - - - - - - - -
'\v/3'
//
/Var C
@- - - - - - - - - - - - - - - - - - - -
(.57735,.33333)
//
/Var c
@- - - - - - - - - - - - - - - - - - - -
2
//
/Var CST
@- - - - - - - - - - - - - - - - - - - -
tri
//
/Var disp
@ display variables & calc some
\<<
   { a b c \Ga \Gb \Gg A h C }         @ items to diaplay &/ round
   \-> l
   \<<
      CLLCD
      \->A
      \->C
      l 1
      DO                               @ round vars if real
         GETI
         \-> v
         \<<
            IF
               v VTYPE 0 ==
            THEN
               v RCL 9 RND v STO
            END
         \>>
      UNTIL
         -64 FS?
      END
      DROP                             @ clear index
      LDISP                            @ display list
   \>>
\>>
//
/Var FLAG
@ flag setting menu
\<<
   "CON" -2 1 flgstr
   "FUN" -3 2 flgstr
   "FRM"  5 3 flgstr
   3 \->LIST 'flgmnu' STO
   flgmnu TMENU
\>>
//
/Var flgmnu
@- - - - - - - - - - - - - - - - - - - -
{
   { "CON" \<< -2 1 flag \>> }
   { "FUN" \<< -3 2 flag \>> }
   { "FRM" \<<  5 3 flag \>> }
}
//
/Var h
@- - - - - - - - - - - - - - - - - - - -
1
//
/Var input
@ input subroutine for tirnagle solutions
\<<
   CLLCD
   3 \->LIST                           @ var list
   "TRI:" ROT + SWAP                   @ title
   IF
      5 FS?
   THEN                                @ INFORM
      1 SWAP AINFORM                   @ add index
   ELSE                                @ INPUT
      AINPUT
   END
\>>
//
/Var PIC
@ graphical help screen
@ uses largest lettering
\<<
   RCLF
   \-> f
   \<<
      1.01 MENU
      { # 0h # 0h } PVIEW
      # 80h # 40h PDIM
      -6.5 6.5 XRNG
      -3.1 3.2 YRNG
@- - - - - - - - - - - - - - - - - - - - triangle & height
      ( 0, 2) ( 4,-1) LINE
      ( 4,-1) (-4,-1) LINE
      (-4,-1) ( 0, 2) LINE
      ( 0, 2) ( 0,-1) LINE
@- - - - - - - - - - - - - - - - - - - - centroid
      DEG
      ( 0, 0) .1 0 360 ARC
@- - - - - - - - - - - - - - - - - - - - angle labels
      "\Ga" 3 5 19.25 GDISP
      "\Gb" 3 1 11.5 GDISP
      "\Gg" 3 5 3.75 GDISP
@- - - - - - - - - - - - - - - - - - - - side labels
      "a" 3 2.75 7.25 GDISP
      "b" 3 5.5 11.25 GDISP
      "c" 3 2.75 15.75 GDISP
@- - - - - - - - - - - - - - - - - - - - other lables
      "h" 3 3 12.25 GDISP
      "A" 3 4 14 GDISP
      "C" 3 3.75 10.5 GDISP
@- - - - - - - - - - - - - - - - - - - - title
      "Triangle" 3 1 2 GDISP
      "Solutions" 3 1 14 GDISP
@- - - - - - - - - - - - - - - - - - - - freeze display & restore flags
      3 FREEZE
      f STOF
   \>>
\>>
//
/Var PPAR
@- - - - - - - - - - - - - - - - - - - -
{ (-6.5,-3.1)
(6.5,3.2) X 0 (0,0)
FUNCTION Y }

//
/Var SAA
@ SAA
@ uses: \Ga\Gb\->\Gg & a\Ga\Gb\->b
\<<
   "SAA" 'a' '\Ga' '\Gb' input

@  var   var   var   fx       var   sto
   \Ga     \Gb           \Ga\Gb\->\Gg   '\Gg' STO
   a     \Ga     \Gb     a\Ga\Gb\->b    'b'   STO
   a     \Ga     \Gg   a\Ga\Gb\->b    'c'   STO

   disp
\>>
//
/Var SAS
@ SAS
@ uses: ab\Gg\->c & a\Gab\->\Gb
\<< "
   SAS" 'a' '\Gg' 'b' input

@  var   var   var   fx       var   sto
   a     b     \Gg   ab\Gg\->c  'c' STO
   c     \Gg   a     a\Gab\->\Gb    '\Ga' STO
   c     \Gg   b     a\Gab\->\Gb    '\Gb' STO

   disp
\>>
//
/Var SSA
@ SSA
@ uses: a\Gab\->\Gb & \Ga\Gb\->\Gg
\<<
   "SSA" 'a' 'b' '\Ga' input

@  var   var   var   fx       var   sto
   a     \Ga     b     a\Gab\->\Gb    '\Gb'   STO
   \Ga     \Gb           \Ga\Gb\->\Gg   '\Gg' STO
   a     \Ga     \Gg   a\Ga\Gb\->b    'c'   STO

   disp
\>>
//
/Var SSS
@ SSS
@ uses: abc\->\Gg
\<< "SSS" 'a' 'b' 'c' input

@  var   var   var   fx       var   sto
   a     b     c     abc\->\Gg  '\Gg' STO
   a     c     b     abc\->\Gg  '\Gb'   STO
   b     c     a     abc\->\Gg  '\Ga'   STO

   disp
\>>
//
/Var tri
@- - - - - - - - - - - - - - - - - - - -
{
   MAIN     ASA      SAS      SAA      SSA         SSS
   disp     PIC      FLAG     CLKMNU   UTIL        A
   a        b        c        \Ga        \Gg         \Gb
   h        C
}
