// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN CONV }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN CONV }
various conversion units & prgms
//
/Var \->QN
@ fraction to nearest N
\<<
   \-> m n
   \<<
      m \->NUM IP m \->NUM FP n * 0 RND n \047 \->Q +
   \>>
\>>
//
/Var \->QP
@ convert number to fraction using # places
@ does three different conversions giving different results
@ uses: \->QR
\<<
   RCLF
   \-> n p f
   \<<
      p FIX
      n \->Q \->QR                     @ full conversion
      n IPFP \->Q +                    @ fractional part conversion
      STD
      n p RND IPFP \->Q +              @ rounded conversion
      \-> a b c                        @ error tagging
      \<<
         2 ENG
         a n a EVAL - \->STR \->TAG
         b n b EVAL - \->STR \->TAG
         c n c EVAL - \->STR \->TAG
      \>>
      f STOF
   \>>
\>>
//
/Var \->QR
@ reduce fraction
\<<
   DUP OBJ\-> DROP2 DUP2 MOD
   \-> q n d m
   \<<
      IF n d >
         THEN                          @ reduction
            "'"                        @ leading ALG
            n m - d / \->STR +         @ whole number
            "+" +
            m \->STR +                 @ numerator
            "/" +
            d \->STR +                 @ denominator
            "'" +                      @ trailing ALG
            OBJ\->                     @ str \-> obj
         ELSE                          @ no reduction
            q
      END
   \>>
\>>
//
/Var acad
@ ???
{
   :c: '299792458_m/s'
   :q: '1.60217733E-19_C'
   :h: '6.6260755E-34_J*s'
   :k: '1.380658E-23_J/K'
   :me: '9.1093897E-31_kg'
   0 0
}
//
/Var ACAD
@ I forget what this is
\<<
   1
   \-> S
   \<<
      1
      DO \-> I
         \<<
            I GETI 'acad' I GET UBASE SWAP
            IF I 6 <
               THEN
                  ^
               ELSE
                  +
            END
            'S'
            IF I 7 <
               THEN
                  STO*
               ELSE
                  STO+
            END
         \>>
      UNTIL
         -64 FS?
      END
      DROP2 S
   \>>
\>>
//
/Var C\->F
@ C to F dual str
\<<
   '1_\^oC' \->UNIT                    @ C unit
   DUP O\->S " " +                     @ C str
   SWAP '1_ \^oF' CONVERT              @ C to F convert
   O\->S +                             @ F str
\>>
//
/Var C\->FR
@ C to F range
@ given starting C & delta display 7 conversions
@ uses: C\->F
\<<
   SWAP OVER -
   \-> s t
   \<<
      1 7
      FOR n
         n s * t + C\->F n DISP
      NEXT
      7 FREEZE
   \>>
\>>
//
/Var cicero
@ conversion factor
'765.354330709_design'
//
/Var conv
{
{ GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
REG
{
   "FRAC"
   \<<
      {
         \->Q \->Q\pi \->QN \->QP \->QR FRAC MODN MOD\->
      }
      TMENU
   \>>
}
LENG MASS PRESS TEMP time type VOL UNITS ubase ACAD
{ GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
{ GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var cpi
@ conversion factor
'1_1/in'
//
/Var CPI
@ char per inch
\<<
   '1_in' CONVERT INV '1_cpi' CONVERT
\>>
//
/Var CPIB
@ ???
\<<
   '1_1/in' CONVERT INV
\>>
//
/Var CPIU
@ ???
\<<
   '1_cpi' *
\>>
//
/Var CST
conv
//
/Var design
@ conversion factor
'1.38888888889E-3_POINT'
//
/Var disp
@ ???
\<<
   12 5 SF RJST 'Ldisp' INCR 8 MOD DUP 'Ldisp' STO 1 +
   1 2 GDISP
   { # 0d # 0d } PVIEW
\>>
//
/Var FDISP
@ fraction display
@ used by: FRAC
\<<
   16
   \-> N F E R
   \<<
      CLLCD
      N \->STR R 1 - RJST 4 DISP
      F \->STR R RJST 5 DISP
      E \->STR R 1 - RJST "\<<ERROR" + 6 DISP
      2 FREEZE
      N F
   \>>
\>>
//
/Var FRAC
@ given N & nearest Q display fraction & error
@ uses: FDISP, REDUCE
\<<
   RCLF
   \-> Q D F
   \<<
      Q IPFP D * 0 RND
      \-> W N
      \<<
         N D REDUCE
         'D' STO
         'N' STO
         STD
         Q
         "'"
         W \->STR +
         "+" +
         N \->STR +
         "/" +
         D \->STR +
         "'" +
         OBJ\->
         DUP EVAL Q -
         F STOF
      \>>
   \>>
   FDISP
\>>
//
/Var ftH2O
@ conversion factor
'12_inH2O'
//
/Var ftSEA
@ conversion factor
'3.33333333333E-2_atm'
//
/Var GRID
@ ???
\<<
   \-> P M G
   \<<
      M P M 2 * - G MOD 2 / +
   \>>
\>>
//
/Var H2O
@ weight of H2O per gallon based on 1_g/cc
@ uses CONLIB now included on the 48GX
@ H2O: 8.345E0_lb/gal
\<<
   '1_gal' '1_l' CONVERT
   '1_gal' / ' 1000_g/l' * '1_g' ' 1_lb' CONVERT
   '1_g' \047 * "H2O" \->TAG
\>>
//
/Var HEADING
@ ???
\<<
   \-> N
   \<<
      N N 15 * 11 / 0 RND N 2 * 3 \->LIST
   \>>
\>>
//
/Var IN\->FT
@ inches to inches, feet
\<<
   '1_in' * '1_ft' CONVERT IPFP '1_in' CONVERT 4 RND
\>>
//
/Var inx
@ conversion factor
'51840_design'
//
/Var Ldisp
@ counter
1
//
/Var LENG
@ length menu
\<<
   {
      '1_nmi'     '1_mi'      '1_km'      '1_m'       '1_yd'
      '1_ft'      '1_in'      '1_cm'      '1_mm'      '1_mil'
      '1 _\Gm'      '1_\197'       '1_miUS'    '1_chain'   '1_rd'
      '1 _fath'   '1_ftUS'    { }         '1_Mpc'     '1_pc'
      '1_lyr'     '1_au'      { }         { }
   }
   TMENU
\>>
//
/Var length
@ length menu
\<<
   {
      '1_m'    '1_ft'   '1_km'   '1_mi'   '1_nmi'  '1_M'
   }
   TMENU
\>>
//
/Var M
@ conversion factor
'1000_ft'
//
/Var MASS
@ mass menu
\<<
   {
      '1_kg'   '1_g'    '1_lb'   '1_oz'
   }
   TMENU
\>>
//
/Var mmx
@ conversion factor
'2040.94488189_design'
//
/Var mnub
@ ???
\<<
   42.01 + MENU
\>>
//
/Var mnuc
@ ???
{
   \<<  1 mnub \>>
   \<<  2 mnub \>>
   \<<  3 mnub \>>
   \<<  4 mnub \>>
   \<<  5 mnub \>>
   \<<  6 mnub \>>
   \<<  7 mnub \>>
   \<<  8 mnub \>>
   \<<  9 mnub \>>
   \<< 10 mnub \>>
   \<< 11 mnub \>>
   \<< 12 mnub \>>
   \<< 13 mnub \>>
   \<< 14 mnub \>>
   \<< 15 mnub \>>
   \<< 16 mnub \>>
}
//
/Var mnun
@ ???
7
//
/Var mnus
@ ???
{
   "LENGTH"    "AREA"   "VOLUME"    "TIME"      "SPEED"        "MASS"
   "FORCE"     "ENERGY" "POWER"     "PRESSURE"  "TEMPERATURE"  "ELECTRICITY"
   "ANGLE"     "LIGHT"  "RADIATION" "VISCOSITY"
}
//
/Var mnut
@ ???
"UNITS"
//
/Var mo
@ conversion factor
'8.33333333333E-2_yr'
//
/Var MOD\->
@ ???
\<<
   OBJ\-> ROT OBJ\->
   \-> a b c d
   \<<
      a b OBJ\->
      c d OBJ\-> + 1
      b OBJ\->
      d OBJ\->
   \>>
\>>
//
/Var MODN
@ ???
\<<
   RCLF \-> a n f
   \<<
      a n / IP
      \-> b
      \<<
         STD
         b UVAL
         n \->STR
         "*" + \->TAG
         a b n * -
         "1*" \->TAG
      \>>
      f STOF
   \>>
\>>
//
/Var pica
@ conversion factor
'8640_design'
//
/Var point
@ conversion factor
'1.38888888889E-2_in'
//
/Var POINT
@ conversion factor
'1.38888888889E-2_in'
//
/Var PP
@ ???
\<<
   "------------------" 4 DISP
   "Pica Point Convert" 3 DISP
   3 10
   \-> R1 R2
   \<<
      DUP COLCT
      '1_inx' * '1_point' PP.CVT CEIL
      DUP
      '1_inx' PP.CVT R1 RND
      SWAP
      '1_pica' PP.CVT IPFP '1_point' PP.CVT R2 RND CEIL
      "Build List" 3 DISP
      \-> A B C D
      \<<
         IF A TYPE 5 ==
            THEN
               A SIZE
               \-> S
               \<<
                  1 S
                  FOR N
                     A N GET C N GET D N GET PP.STR B N GET 3 \->LIST
                  NEXT
                  S \->LIST
               \>>
            ELSE
               A C D PP.STR B 3 \->LIST
         END
      \>>
   \>>
\>>
//
/Var PP.CVT
@ ???
\<<
   DUP 3 DISP CONVERT
\>>
//
/Var PP.PRN
@ ???
\<<
   PP PRLST PREJT
\>>
//
/Var PP.STR
@
\<<
   RCLF
   \-> A B F
   \<<
      STD A UVAL \->STR "," + B UVAL \->STR + " pica" + F STOF
   \>>
\>>
//
/Var PRDIV
@ ???
\<<
   IF
      THEN
         "/----------\092"
      ELSE
         "\092----------/"
   END
   PRx2
\>>
//
/Var PREJT
@
\<<
   "Eject" 3 DISP
   1 4
   START
      CR
   NEXT
\>>
//
/Var PRESS
@ pressure meny
\<<
   {
      '1_atm'     '1_bar'     '1_mbar'    '1_psi'     '1_mmHg'
      '1_inHg'    '1_inH2O'   '1_ftH2O'   '1_ftSEA'
      UVAL
   }
   TMENU
\>>
//
/Var PRLST
\<<
   1 PRDIV 1
   DO
      \-> I
      \<<
         I GETI
         IF DUP TYPE 5 ==
            THEN
               RCLF SWAP PRLST DROP STOF
            ELSE
               PRx2
         END
      \>>
   UNTIL
      -64 FS?
   END
   DROP 0 PRDIV
\>>
//
/Var PRx2
@ ???
\<<
   IF 21 FS?
      THEN
         -38 SF "\027\253" PR1 DROP PR1 -38 CF "\027\252" PR1 CR DROP
   END
   disp
\>>
//
/Var REDUCE
@ fraction reduction
@ not sure how this works
@ have a fraction reduction prgm \->QR that works with ALG
@ used by: FRAC
\<<
   \-> A B
   \<<
      WHILE A EVEN B EVEN AND
      REPEAT
         A 2 / 'A' STO
         B 2 / 'B' STO
      END
      A B
   \>>
\>>
//
/Var TEMP
@ temperature menu
\<<
   {
      { }   '1_\^oC'   { }   { }   '1_\^oF'
   }
   TMENU
\>>
//
/Var time
@ time menu
\<<
   {
      DATE     TIME     TSTR     DOW      DOY      JULIAN
      DATE+    DDAYS    \->HMS     HMS\->     HMS+     HMS-
      '1_yr'   '1_mo'   '1_wk'   '1_d'    '1_h'    '1_min'     '1_s'
   }
   TMENU
\>>
//
/Var TMPA
@ ???
\<<
   '1_1/km' \->UNIT '1_1/M' CONVERT
\>>
//
/Var TMPB
@ ???
\<<
   '1_kg/km' \->UNIT '1_lb/M' CONVERT
\>>
//
/Var twip
@ conversion factor
'36_design'
//
/Var type
@ type menu
\<<
   {
      '1_mm'      '1_in'      '1_mmx'     '1_inx'     '1_pica'    '1_point'
      '1_twip'    '1_cicero'  '1_design'  '1_wrt'     { }
      { "-CPI-" { CPIU CPI CPIB } }
      PP    { }   PP.PRN   { }   PRLST    PREJT    MODN     MOD\->
   }
   TMENU
\>>
//
/Var TYRE
@ ???
\<<
   RCLF
   \-> F
   \<<
      '1_in' \->UNIT \pi SWAP * \->NUM '1_mm' CONVERT
      STD 0 RND \->STR CLLCD 5 DISP 2 FREEZE F STOF
   \>>
\>>
//
/Var ubase
@ converts unit to UBASE satring
@ need string & unit on stack
\<<
   \-> u
   \<<
      u O\->S 9 LJST
      " \-> " +
      u UBASE O\->S +
      DUP 3 DISP
      10 CHR + +
   \>>
\>>
//
/Var UNITS
\<< 59.01 MENU
\>>
//
/Var untlst
"
1_Db     \-> 1.E-27_m^2
1_\^o      \-> 1.74532925199E-2_r
1_grad   \-> 1.57079632679E-2_r
1_arcmin \-> 2.90888208666E-4_r
1_r      \-> 1_r
1_arcs   \-> 4.8481368111E-6_r
1_sr     \-> 1_sr
1_acre   \-> 4046.87260987_m^2
1_a      \-> 100_m^2
1_b      \-> 1.E-28_m^2
1_cm^2   \-> .0001_m^2
1_ft^2   \-> .09290304_m^2
1_ha     \-> 10000_m^2
1_in^2   \-> .00064516_m^2
1_km^2   \-> 1000000_m^2
1_m^2    \-> 1_m^2
1_mi^2   \-> 2589988.11034_m^2
1_miUS^2 \-> 2589998.47032_m^2
1_yd^2   \-> .83612736_m^2
1_A      \-> 1_A
1_C      \-> 1_A*s
1_F      \-> 1_A^2*s^4/(kg*m^2)
1_Fdy    \-> 96487_A*s
1_H      \-> 1_kg*m^2/(A^2*s^2)
1_mho    \-> 1_A^2*s^3/(kg*m^2)
1_\GW      \-> 1_kg*m^2/(A^2*s^3)
1_S      \-> 1_A^2*s^3/(kg*m^2)
1_T      \-> 1_kg/(A*s^2)
1_V      \-> 1_kg*m^2/(A*s^3)
1_W      \-> 1_kg*m^2/s^3
1_Wb     \-> 1_kg*m^2/(A*s^2)
1_Btu    \-> 1055.05585262_kg*m^2/s^2
1_cal    \-> 4.1868_kg*m^2/s^2
1_therm  \-> 105506000_kg*m^2/s^2
1_eV     \-> 1.60217733E-19_kg*m^2/s^2
1_erg    \-> .0000001_kg*m^2/s^2
1_ftlb   \-> 4.21401100938E-2_kg*m^2/s^2
1_ft*lbf \-> 1.35581794833_kg*m^2/s^2
1_hp*h   \-> 2684519.5377_kg*m^2/s^2
1_J      \-> 1_kg*m^2/s^2
1_kcal   \-> 4186.8_kg*m^2/s^2
1_MeV    \-> 1.60217733E-13_kg*m^2/s^2
1_W*h    \-> 3600_kg*m^2/s^2
1_dyn    \-> .00001_kg*m/s^2
1_gf     \-> .00980665_kg*m/s^2
1_kip    \-> 4448.22161526_kg*m/s^2
1_N      \-> 1_kg*m/s^2
1_lbf    \-> 4.44822161526_kg*m/s^2
1_pdl    \-> .138254954376_kg*m/s^2
1_\197      \-> .0000000001_m
1_au     \-> 149597900000_m
1_cm     \-> .01_m
1_chain  \-> 20.1168402337_m
1_fath   \-> 1.82880365761_m
1_fermi  \-> 1.E-15_m
1_ft     \-> .3048_m
1_ftUS   \-> .304800609601_m
1_in     \-> .0254_m
1_km     \-> 1000_m
1_lyr    \-> 9.46052840488E15_m
1_Mpc    \-> 3.08567818585E22_m
1_m      \-> 1_m
1_\Gm      \-> .000001_m
1_mil    \-> .0000254_m
1_mi     \-> 1609.344_m
1_nmi    \-> 1852_m
1_miUS   \-> 1609.34721869_m
1_mm     \-> .001_m
1_pc     \-> 3.08567818585E16_m
1_rd     \-> 5.02921005842_m
1_yd     \-> .9144_m
1_cd     \-> 1_cd
1_fc     \-> 10.7639104167_cd*sr/m^2
1_flam   \-> 3.42625909964_cd/m^2
1_lam    \-> 3183.09886184_cd/m^2
1_lm     \-> 1_cd*sr
1_lx     \-> 1_cd*sr/m^2
1_pt     \-> .000473176473_m^3
1_sb     \-> 10000_cd/m^2
1_u      \-> 1.6605402E-27_kg
1_ct     \-> .0002_kg
1_grain  \-> .00006479891_kg
1_g      \-> .001_kg
1_kg     \-> 1_kg
1_mol    \-> 1_mol
1_oz     \-> .028349523125_kg
1_ozt    \-> .0311034768_kg
1_lb     \-> .45359237_kg
1_lbt    \-> .3732417216_kg
1_slug   \-> 14.5939029372_kg
1_tonUK  \-> 1016.0469088_kg
1_t      \-> 1000_kg
1_ton    \-> 907.18474_kg
1_hp     \-> 745.699871582_kg*m^2/s^3
1_W      \-> 1_kg*m^2/s^3
1_atm    \-> 101325_kg/(m*s^2)
1_bar    \-> 100000_kg/(m*s^2)
1_psi    \-> 6894.75729317_kg/(m*s^2)
1_inHg   \-> 3386.38815789_kg/(m*s^2)
1_mmHg   \-> 133.322368421_kg/(m*s^2)
1_Pa     \-> 1_kg/(m*s^2)
1_torr   \-> 133.322368421_kg/(m*s^2)
1_inH2O  \-> 248.84_kg/(m*s^2)
1_Bq     \-> 1_1/s
1_Ci     \-> 37000000000_1/s
1_Gy     \-> 1_m^2/s^2
1_mSv    \-> .001_m^2/s^2
1_rad    \-> .01_m^2/s^2
1_rem    \-> .01_m^2/s^2
1_R      \-> .000258_A*s/kg
1_Sv     \-> 1_m^2/s^2
1_cm/s   \-> .01_m/s
1_ft/s   \-> .3048_m/s
1_ga     \-> 9.80665_m/s^2
1_kph    \-> .277777777778_m/s
1_knot   \-> .514444444444_m/s
1_m/s    \-> 1_m/s
1_mph    \-> .44704_m/s
1_c      \-> 299792458_m/s
1_\^oC     \-> 274.15_K
1_\^oF     \-> 255.927777778_K
1_K      \-> 1_K
1_\^oR     \-> .555555555556_K
1_d      \-> 86400_s
1_Hz     \-> 1_1/s
1_h      \-> 3600_s
1_min    \-> 60_s
1_rpm    \-> 1.66666666667E-2_1/s
1_s      \-> 1_s
1_yr     \-> 31556925.9747_s
1_P      \-> .1_kg/(m*s)
1_St     \-> .0001_m^2/s
1_bbl    \-> .158987294928_m^3
1_fbm    \-> .002359737216_m^3
1_bu     \-> .03523907_m^3
1_cm^3   \-> .000001_m^3
1_cu     \-> 2.365882365E-4_m^3
1_ft     \-> .3048_m
1_galC   \-> .00454609_m^3
1_galUK  \-> .004546092_m^3
1_gal    \-> .003785411784_m^3
1_in     \-> .0254_m
1_l      \-> .001_m^3
1_m^3    \-> 1_m^3
1_ml     \-> .000001_m^3
1_ozfl   \-> 2.95735295625E-5_m^3
1_ozUK   \-> .000028413075_m^3
1_pk     \-> .0088097675_m^3
1_pt     \-> .000473176473_m^3
1_qt     \-> .000946352946_m^3
1_st     \-> 1_m^3
1_tbsp   \-> 1.47867647813E-5_m^3
1_tsp    \-> 4.92892159375E-6_m^3
1_yd     \-> .9144_m
"
//
/Var UNTLST
@ string list of units
\<<
   CLLCD 10 CHR
   1_Db     ubase
   1_\^o      ubase
   1_grad   ubase
   1_arcmin ubase
@  1_2*?*r  ubase
   1_r      ubase
   1_arcs   ubase
   1_sr     ubase
   1_acre   ubase
   1_a      ubase
   1_b      ubase
   1_cm^2   ubase
   1_ft^2   ubase
   1_ha     ubase
   1_in^2   ubase
   1_km^2   ubase
   1_m^2    ubase
   1_mi^2   ubase
   1_miUS^2 ubase
   1_yd^2   ubase
   1_A      ubase
   1_C      ubase
   1_F      ubase
   1_Fdy    ubase
@  1_-      ubase  gauss
   1_H      ubase
   1_mho    ubase
   1_\GW      ubase
   1_S      ubase
   1_T      ubase
   1_V      ubase
   1_W      ubase
   1_Wb     ubase
   1_Btu    ubase
   1_cal    ubase
   1_therm  ubase
   1_eV     ubase
   1_erg    ubase
   1_ftlb   ubase
   1_ft*lbf ubase
   1_hp*h   ubase
   1_J      ubase
   1_kcal   ubase
   1_MeV    ubase
   1_W*h    ubase
   1_dyn    ubase
   1_gf     ubase
   1_kip    ubase
   1_N      ubase
   1_lbf    ubase
   1_pdl    ubase
   1_\197      ubase
   1_au     ubase
   1_cm     ubase
   1_chain  ubase
   1_fath   ubase
   1_fermi  ubase
   1_ft     ubase
   1_ftUS   ubase
   1_in     ubase
   1_km     ubase
   1_lyr    ubase
   1_Mpc    ubase
   1_m      ubase
   1_\Gm      ubase
   1_mil    ubase
   1_mi     ubase
   1_nmi    ubase
   1_miUS   ubase
   1_mm     ubase
   1_pc     ubase
@  1_-      ubase pica
   1_rd     ubase
   1_yd     ubase
   1_cd     ubase
   1_fc     ubase
   1_flam   ubase
   1_lam    ubase
   1_lm     ubase
   1_lx     ubase
   1_pt     ubase
   1_sb     ubase
   1_u      ubase
   1_ct     ubase
   1_grain  ubase
   1_g      ubase
   1_kg     ubase
   1_mol    ubase
   1_oz     ubase
   1_ozt    ubase
   1_lb     ubase
   1_lbt    ubase
   1_slug   ubase
   1_tonUK  ubase
   1_t      ubase
   1_ton    ubase
   1_hp     ubase
   1_W      ubase
   1_atm    ubase
   1_bar    ubase
   1_psi    ubase
   1_inHg   ubase
   1_mmHg   ubase
   1_Pa     ubase
   1_torr   ubase
   1_inH2O  ubase
   1_Bq     ubase
   1_Ci     ubase
   1_Gy     ubase
   1_mSv    ubase
   1_rad    ubase
   1_rem    ubase
   1_R      ubase
   1_Sv     ubase
   1_cm/s   ubase
   1_ft/s   ubase
   1_ga     ubase
   1_kph    ubase
   1_knot   ubase
   1_m/s    ubase
   1_mph    ubase
   1_c      ubase
   1_\^oC     ubase
   1_\^oF     ubase
   1_K      ubase
   1_\^oR     ubase
   1_d      ubase
   1_Hz     ubase
   1_h      ubase
   1_min    ubase
   1_rpm    ubase
   1_s      ubase
   1_yr     ubase
   1_P      ubase
   1_St     ubase
   1_bbl    ubase
   1_fbm    ubase
   1_bu     ubase
   1_cm^3   ubase
   1_cu     ubase
   1_ft     ubase
   1_galC   ubase
   1_galUK  ubase
   1_gal    ubase
   1_in     ubase
   1_l      ubase
   1_m^3    ubase
   1_ml     ubase
   1_ozfl   ubase
   1_ozUK   ubase
   1_pk     ubase
@  1_-      ubase uk_pt
   1_pt     ubase
   1_qt     ubase
   1_st     ubase
   1_tbsp   ubase
   1_tsp    ubase
   1_yd     ubase
   'untlst' STO
\>>
//
/Var wk
@ conversion factor
'7_d'
//
/Var wrt
@ conversion factor
'.703125_design'
