// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir
/AutoExec
//
/Var \->\->NOTES
@ graphics apps
@ GROBS found in C:\HP48\GRAPHICS
//
/Var ANI
@ uses built-in ANIMATE to display GROB's
\<<
   11 TVARS 1
   DO
      \-> i
      \<<
         i GETI
         \-> v
         \<<
            v i 1 - 7 MOD 1 + DISP     @ show progress
            v EVAL 3 ROLLD             @ get GROB
         \>>
      \>>
   UNTIL
      -64 FS?
   END
   DROP
   SIZE { # 0d # 0d } 1 1              @ control list
   4 \->LIST
   ANIMATE
   1 GET DROPN                         @ clear ani stack
\>>
//
/Var graphics
@ custom menu
{ {
GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1
UPDIR } PICS RNDM
SINGLE {
GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1
ABITCH } {
GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0
EXE } }
//
/Var GROBD
@ GROBDisplay
@ used by: SINGLE
\<<
   PICT STO { # 0d # 0d } PVIEW 3 FREEZE 3 WAIT
\>>
//
/Var PICS
@ display GROB's
\<<
   1 CF 2 CF 3 CF CLLCD 11 TVARS 1
   DO
      \-> n
      \<<
         n GETI
         \-> v
         \<<
            v EVAL PICT STO            @ put GROB in PICT
            v n 1 \->STRN \->TAG       @ GROB name
            10.6 1 1 GDISP             @ graphic display
            -1 n 1 - .1                @ note freq
         \>>
      \>>
      { # 0d # 0d } PVIEW              @ show PICT
      NOTE                             @ play note
      1 WAIT
   UNTIL
      -64 FS?
   END
   DROP2
\>>
//
/Var RNDM
@ random GROB display
\<<
   CLLCD
   "Any Key Quits" CNTR2 4 DISP 3 WAIT
   11 TVARS                            @ GROB's
   DUP SIZE                            @ # of GROB's
   \-> l s
   \<<
      { # 0d # 0d } PVIEW
      DO
         l                             @ GROB list
         s 1 - RAND * 0 RND 1 +        @ random #
         GET EVAL PICT STO             @ sto GROB in PICT
         3 WAIT
      UNTIL
         KEY
      END
      DROP
   \>>
\>>
//
/Var SINGLE
@ single display of GROB's using menu
@ uses: GROBD
\<<
   11 TVARS 1
   DO                                  @ build menu list
      \-> i
      \<<
         i GETI
         \-> v
         \<<
            v i 1 \->STRN \->TAG       @ display progress
            i 1 - 7 MOD 1 + DISP
            v O\->S                    @ GROB menu label
            "\<<" v " GROBD \>>"       @ GROB prgm
            + + OBJ\-> 2 \->LIST       @ menu element
            3 ROLLD
         \>>
      \>>
   UNTIL
      -64 FS?
   END
   DROP SIZE \->LIST                   @ combine menu elements
   TMENU
\>>
