// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN MACH BAC }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN MACH BAC }
ACCURATE BEND ALLOWANCE
the more accurate bend allowance calculations
//
/Var \Gh
@ variable
8.99935395557E-2
//
/Var ba
@ the accurate BAC EQ
'D\->R(\Gh)*(R+M*(1/3+(1/2-1/3)*(1-EXP(-.55*R/M))))'
//
/Var BA
@ bend allowance calculation
\<<
   CLLCD 28 MENU
   "Bend Allowance"
   ":M: " M \->STR +
"
   :R: " R \->STR + +
"
   :\Gh: " \Gh \->STR + +
   { -1 5 } 'V' 'ALG' 4 \->LIST INPUT OBJ\->
   1 3
   START
      OBJ\-> obj\-> STO
   NEXT
   IF M R >
      THEN
         'D\->R(\Gh)*(M/3+R)'
      ELSE
         'D\->R(\Gh)*(M/2+R)'
   END
   EVAL \->NUM 'Q' STO "BEND CALC" 'MSG' STO disp
   { M Q R \Gh disp BA }    TMENU
\>>
//
/Var bac
@ custom menu
{
{ GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
BA
{ "BAC" \<< BAC1 disp \>> }
vars REG tmenu
{ GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
{ GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var BAC0
@ BAC routine
\<<
   BA CL\GS BAC1
\>>
//
/Var BAC1
@ BAC menu
\<<
   {
      { "IE"      \<< 0 BAC2 \>> }
      { "OE"      \<< 1 BAC2 \>> }
      { "II"      \<< 0 BAC2 \>> }
      { "IO"      \<< 1 BAC2 \>> }
      { "OO"      \<< 2 BAC2 \>> }
      { "CALC"    \<< BAC3 \>> }
      { "RESET"   \<< BAC0 \>> }
      { "CL\GS"     \<< CL\GS BAC1 disp \>> }
      { "DISP"    \<< BAC1 disp \>> }
      vars
   } TMENU
\>>
//
/Var BAC2
@ BAC routine
\<<
   \-> I
   \<<
      "Enter Dimension"
      { ":DIM:''" { 1 7 } \Ga V ALG } 28 MENU
      INPUT 0 MENU OBJ\-> DTAG \->NUM I { 2 } \->ARRY \GS+
   \>>
\>>
//
/Var BAC3
@ BAC routine
\<<
   \GSX \GSY M * - N\GS 2 * 2 - R * - N\GS 1 - Q * + EVAL
\>>
//
/Var disp
@ BAC routine
\<<
   RCLF 4 FIX { MSG M Q R \Gh } DISPV STOF
\>>
//
/Var M
@ variable
.125
//
/Var MSG
@ message string
"BEND CALC"
//
/Var Q
@ vaariable
8.99935395557E-2
//
/Var R
@ variable
'1/64'
//
/Var vars
@ BAC routine
\<<
   { M Q R \Gh { "BAC" \<< BAC1 disp \>> } } TMENU
\>>
