// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN MACH }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN MACH }
MACHINE APPLICATIONS
various machine programs
bend allowance
drill sizes
screw calculations
wire sizes
etc.
//
/Var \Gh
@ variable
4.96764338347E-2
//
/Var ALETT
%%HP: T(3)A(D)F(.);
[[ .234 ]
 [ .238 ]
 [ .242 ]
 [ .246 ]
 [ .25 ]
 [ .257 ]
 [ .261 ]
 [ .266 ]
 [ .272 ]
 [ .277 ]
 [ .281 ]
 [ .29 ]
 [ .295 ]
 [ .302 ]
 [ .316 ]
 [ .323 ]
 [ .332 ]
 [ .339 ]
 [ .348 ]
 [ .358 ]
 [ .368 ]
 [ .377 ]
 [ .386 ]
 [ .397 ]
 [ .404 ]
 [ .413 ]]
//
/Var ANUMB
%%HP: T(3)A(D)F(.);
[[ .0135 ]
 [ .0145 ]
 [ .016 ]
 [ .018 ]
 [ .02 ]
 [ .021 ]
 [ .0225 ]
 [ .024 ]
 [ .025 ]
 [ .026 ]
 [ .028 ]
 [ .0292 ]
 [ .031 ]
 [ .032 ]
 [ .033 ]
 [ .035 ]
 [ .036 ]
 [ .037 ]
 [ .038 ]
 [ .039 ]
 [ .04 ]
 [ .041 ]
 [ .042 ]
 [ .043 ]
 [ .0465 ]
 [ .052 ]
 [ .055 ]
 [ .0595 ]
 [ .0635 ]
 [ .067 ]
 [ .07 ]
 [ .073 ]
 [ .076 ]
 [ .0785 ]
 [ .081 ]
 [ .082 ]
 [ .086 ]
 [ .089 ]
 [ .0935 ]
 [ .096 ]
 [ .098 ]
 [ .0995 ]
 [ .1015 ]
 [ .104 ]
 [ .1065 ]
 [ .11 ]
 [ .111 ]
 [ .113 ]
 [ .116 ]
 [ .12 ]
 [ .1285 ]
 [ .136 ]
 [ .1405 ]
 [ .144 ]
 [ .147 ]
 [ .1495 ]
 [ .152 ]
 [ .154 ]
 [ .157 ]
 [ .159 ]
 [ .161 ]
 [ .166 ]
 [ .1695 ]
 [ .173 ]
 [ .177 ]
 [ .18 ]
 [ .182 ]
 [ .185 ]
 [ .189 ]
 [ .191 ]
 [ .1935 ]
 [ .196 ]
 [ .199 ]
 [ .201 ]
 [ .204 ]
 [ .2055 ]
 [ .209 ]
 [ .213 ]
 [ .221 ]
 [ .228 ]]
//
/Var BEND
@ the simple bend calculation
@ this roughly compensates for the bend radius either 1/3 or 1/2
'Q=D\->R(\Gh)*(M/IFTE(R<M,3,2)+R)'
//
/Var BEND2
@ the accurate bend calculation
@ I tediously calculated this from tabulated data
@ it turns out to be very accurate & compensates for the bend radius
'Q=D\->R(\Gh)*(M*(1/3+1/6*(1-EXP(.55*R/M)))+R)'
//
/Var CNTFRC
@ center fraction
\<<
   0 6 \-> i l
   \<<
      DO
         IPFP INV 'i' INCR DROP
      UNTIL
         DUP FP 0 == i l == OR
      END
      IP 1 2 i
      START
         ROT 3 PICK * + SWAP
      NEXT
      SWAP
   \>>
\>>
//
/Var cuin
@ variable
.375
//
/Var DATA
@ data
@ I had to format this with WORD then EXCEL
@ ARRGGGHHHH!
%%HP: T(3)A(D)F(.);
{
{  .0135 "80"    "#"  }
{  .0145 "79"    "#"  }
{  .0156 "1/64"  "f"  }
{  .016  "78"    "#"  }
{  .018  "77"    "#"  }
{  .02   "76"    "#"  }
{  .021  "75"    "#"  }
{  .0225 "74"    "#"  }
{  .024  "73"    "#"  }
{  .025  "72"    "#"  }
{  .026  "71"    "#"  }
{  .028  "70"    "#"  }
{  .0292 "69"    "#"  }
{  .031  "68"    "#"  }
{  .0313 "1/32"  "f"  }
{  .032  "67"    "#"  }
{  .033  "66"    "#"  }
{  .035  "65"    "#"  }
{  .036  "64"    "#"  }
{  .037  "63"    "#"  }
{  .038  "62"    "#"  }
{  .039  "61"    "#"  }
{  .04   "60"    "#"  }
{  .041  "59"    "#"  }
{  .042  "58"    "#"  }
{  .043  "57"    "#"  }
{  .0465 "56"    "#"  }
{  .0469 "3/64"  "f"  }
{  .052  "55"    "#"  }
{  .055  "54"    "#"  }
{  .0595 "53"    "#"  }
{  .0625 "1/16"  "f"  }
{  .0635 "52"    "#"  }
{  .067  "51"    "#"  }
{  .07   "50"    "#"  }
{  .073  "49"    "#"  }
{  .076  "48"    "#"  }
{  .0781 "5/64"  "f"  }
{  .0785 "47"    "#"  }
{  .081  "46"    "#"  }
{  .082  "45"    "#"  }
{  .086  "44"    "#"  }
{  .089  "43"    "#"  }
{  .0935 "42"    "#"  }
{  .0938 "3/32"  "f"  }
{  .096  "41"    "#"  }
{  .098  "40"    "#"  }
{  .0995 "39"    "#"  }
{  .1015 "38"    "#"  }
{  .104  "37"    "#"  }
{  .1065 "36"    "#"  }
{  .1094 "7/64"  "f"  }
{  .11   "35"    "#"  }
{  .111  "34"    "#"  }
{  .113  "33"    "#"  }
{  .116  "32"    "#"  }
{  .12   "31"    "#"  }
{  .125  "1/8"   "f"  }
{  .1285 "30"    "#"  }
{  .136  "29"    "#"  }
{  .1405 "28"    "#"  }
{  .1406 "9/64"  "f"  }
{  .144  "27"    "#"  }
{  .147  "26"    "#"  }
{  .1495 "25"    "#"  }
{  .152  "24"    "#"  }
{  .154  "23"    "#"  }
{  .1563 "5/32"  "f"  }
{  .157  "22"    "#"  }
{  .159  "21"    "#"  }
{  .161  "20"    "#"  }
{  .166  "19"    "#"  }
{  .1695 "18"    "#"  }
{  .1719 "11/64" "f"  }
{  .173  "17"    "#"  }
{  .177  "16"    "#"  }
{  .18   "15"    "#"  }
{  .182  "14"    "#"  }
{  .185  "13"    "#"  }
{  .1875 "3/16"  "f"  }
{  .189  "12"    "#"  }
{  .191  "11"    "#"  }
{  .1935 "10"    "#"  }
{  .196  "9"     "#"  }
{  .199  "8"     "#"  }
{  .201  "7"     "#"  }
{  .2031 "13/64" "f"  }
{  .204  "6"     "#"  }
{  .2055 "5"     "#"  }
{  .209  "4"     "#"  }
{  .213  "3"     "#"  }
{  .2188 "7/32"  "f"  }
{  .221  "2"     "#"  }
{  .228  "1"     "#"  }
{  .234  "A"     "l"  }
{  .2344 "15/64" "f"  }
{  .238  "B"     "l"  }
{  .242  "C"     "l"  }
{  .246  "D"     "l"  }
{  .25   "1/4"   "f"  }
{  .25   "E"     "l"  }
{  .257  "F"     "l"  }
{  .261  "G"     "l"  }
{  .2656 "17/64" "f"  }
{  .266  "H"     "l"  }
{  .272  "I"     "l"  }
{  .277  "J"     "l"  }
{  .281  "K"     "l"  }
{  .2813 "9/32"  "f"  }
{  .29   "L"     "l"  }
{  .295  "M"     "l"  }
{  .2969 "19/64" "f"  }
{  .302  "N"     "l"  }
{  .3125 "5/16"  "f"  }
{  .316  "O"     "l"  }
{  .323  "P"     "l"  }
{  .3281 "21/64" "f"  }
{  .332  "Q"     "l"  }
{  .339  "R"     "l"  }
{  .3438 "11/32" "f"  }
{  .348  "S"     "l"  }
{  .358  "T"     "l"  }
{  .3594 "23/64" "f"  }
{  .368  "U"     "l"  }
{  .375  "3/8"   "f"  }
{  .377  "V"     "l"  }
{  .386  "W"     "l"  }
{  .3906 "25/64" "f"  }
{  .397  "X"     "l"  }
{  .404  "Y"     "l"  }
{  .4063 "13/32" "f"  }
{  .413  "Z"     "l"  }
{  .4219 "27/64" "f"  }
{  .4375 "7/16"  "f"  }
{  .4531 "29/64" "f"  }
{  .4688 "15/32" "f"  }
{  .4844 "31/64" "f"  }
{  .5    "1/2"   "f"  }
{  .5156 "33/64" "f"  }
{  .5313 "17/32" "f"  }
{  .5469 "35/64" "f"  }
{  .5625 "9/16"  "f"  }
{  .5781 "37/64" "f"  }
{  .5938 "19/32" "f"  }
{  .6094 "39/64" "f"  }
{  .625  "5/8"   "f"  }
{  .6406 "41/64" "f"  }
{  .6563 "21/32" "f"  }
{  .6719 "43/64" "f"  }
{  .6875 "11/16" "f"  }
{  .7031 "45/64" "f"  }
{  .7188 "23/32" "f"  }
{  .7344 "47/64" "f"  }
{  .75   "3/4"   "f"  }
{  .7656 "49/64" "f"  }
{  .7813 "25/32" "f"  }
{  .7969 "51/64" "f"  }
{  .8125 "13/16" "f"  }
{  .8281 "53/64" "f"  }
{  .8438 "27/32" "f"  }
{  .8594 "55/64" "f"  }
{  .875  "7/8"   "f"  }
{  .8906 "57/64" "f"  }
{  .9063 "29/32" "f"  }
{  .9219 "59/64" "f"  }
{  .9375 "15/16" "f"  }
{  .9531 "61/64" "f"  }
{  .9688 "31/32" "f"  }
{  .9844 "63/64" "f"  }
{  1     "1"     "f"  }
}
//
/Var DATGET
@ get line from 'DATA' and parse
\<<
   'DATA' SWAP GET OBJ\-> DROP
   \-> V N T
   \<<
      V N T
   \>>
\>>
//
/Var depth
@ variable
.125
//
/Var dia
@ variable
.0781
//
/Var DIECLR
@ die clearance
\<<
   \-> A B
   \<<
      A B XX
      IF A B <
         THEN
            NEG
      END
      A B YY
   \>>
\>>
//
/Var DISPL
@ display list
\<<
   DUP CLLCD 1
   DO
      GETI
      IF -64 FS?
         THEN
            ROT SIZE
         ELSE
            OVER 1 -
      END
      2 + DISP
   UNTIL
      -64 FS?
   END
   DROP 2 FREEZE
\>>
//
/Var DRILL
@ find closest drill to 'n'
\<<
   RCLF STD
   \-> n f
   \<<
      n 'ALETT' n FIND OBJ\-> SWAP 64 + CHR SWAP 1 - \->LIST
      SWAP DROP 'ANUMB' n FIND OBJ\-> 81 ROT - \->STR "#" SWAP + SWAP 1 - \->LIST
      SWAP DROP n EVAL N64 OBJ\-> 1 - \->LIST
      SWAP DROP f STOF
   \>>
   ERASE 8 6
   FOR I
      I 1 1 GDISP -1
   STEP 3
   1 2 GDISP "Nearest Drills" 1 1 3 GDISP
   { # 0h # 0h } PVIEW 0 WAIT
   DROP
\>>
//
/Var ELETT
@ drill letter EQ
{
ELETT
'63.7648309716+42.3989519375*LN(Y)=X'
'Y=.222256157961*EXP(2.35854886575E-2*X)'
}
//
/Var ENUMB
@ drill number EQ
{
ENUMB
'77.6261672439-359.414472878*Y=X'
'Y=.215979525316+-2.78230309423E-3*X'
}
//
/Var EQS
@ EQ list
{ BEND FEED REMOVE SPEED }
//
/Var FEED
@ feed EQ
'ipm=rpm*fpt*teeth'
//
/Var FESP
@ feed speed
\<<
   10 CHR RCLMENU
   \-> cr mnu
   \<<
      CLLCD 28 MENU
      { ipm teeth dia rpm }
      input
      'ipm/(teeth*rpm)' EVAL \->NUM 'fpt' STO
      '\pi*dia*rpm/12' EVAL \->NUM 'fpm' STO
      { ipm teeth dia rpm fpt fpm }
      DISPV mnu MENU
   \>>
\>>
//
/Var fpm
@ variable
24.5358386245
//
/Var fpt
@ variable
.005
//
/Var FRAC
@ fraction calc
\<<
   EVAL IPFP \->Q +
\>>
//
/Var input
@ imput routine
\<<
   RCLF OVER SIZE STD \->STR SWAP STOF ":" RCLMENU
   \-> L N S M
   \<<
      L 1
      DO
         SWAP OVER GETI RCLF
         \-> O F
         \<<
            ROT STD \->STR F STOF S + N + O EVAL O \->STR DUP SIZE
            \-> Z
            \<<
               2 Z 1 - SUB \->TAG \->STR -1 Z 2 + 2 \->LIST 'V' 3 \->LIST
               28 MENU INPUT OBJ\-> TAG\-> STO
            \>>
         \>>
      UNTIL
         -64 FS?
      END
      DROP2 M MENU
   \>>
\>>
//
/Var ipm
@ variable
12
//
/Var IRON
@ iron weight ??? EQ defined
\<<
   \-> X
   '.373436730455*EXP(-.113073459399*X)'
\>>
//
/Var iron
@ another IRON EQ defined
\<<
   \-> Y
   '-8.71121030845-8.84380831112*LN(Y)'
\>>
//
/Var LENG
@ length EQ for 90\^o
'L=S1+S2-2*(M+R)+\pi/2*(M/3+R)'
//
/Var LETT
@ letter drill
\<<
   RCLF
   \-> a f
   \<<
      a 'ALETT' a NUM 64 - GET 2 \->LIST f STOF
   \>>
\>>
//
/Var lett
@ lettered drill
\<< RCLF \-> n f
  \<< 'ALETT' n FIND
\-> l
    \<< l 3 l 3 GET
    \>> 64 + CHR PUT
  \>>
\>>
//
/Var M
@ variable
.048
//
/Var mach
@ 'mach' CST menu
{
{ GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
BAC REG SOLVR tmenu graph
{ "\->IRON" iron }
{ "\->LETT" lett }
{ "\->NUMB" numb }
{ "\->SCREW" screw }
{ "\->WIRE" wire }
{ }
{ "\<-IRON" IRON }
{ "\<-LETT" LETT }
{ "\<-NUMB" NUMB }
{ "\<-SCREW" SCREW }
{ "\<-WIRE" WIRE }
{ }
NDRILL SDRILL DRILL PILOT TDPTH FESP FRAC N16 N32 N64
{ GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
{ GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var msg
@ message string
"BEND CALC"
//
/Var N16
@ nearest 16th
\<<
   16 NFRAC
\>>
//
/Var N32
@ nearest 32nd
\<<
   32 NFRAC
\>>
//
/Var N64
@ nearest 64th
\<<
   64 NFRAC
\>>
//
/Var NDRILL
@ nearest screw drill
\<<
   \-> n t
   \<<
      n SCREW t SDRILL
   \>>
\>>
//
/Var NUMB
@ numbered drill
\<<
   RCLF \-> n f
   \<<
      STD "#" n \->STR + 'ANUMB' 81 n - GET 2 \->LIST f STOF
   \>>
\>>
//
/Var numb
@ numberd drill
\<<
   RCLF
   \-> n f
   \<<
      'ANUMB' n FIND
      \-> l
      \<<
         l 3 "#" 81 l 3 GET -
      \>>
      STD \->STR + PUT
      f STOF
   \>>
\>>
//
/Var PILOT
@ pilot drill
\<<
   DUP .467 * SWAP .72 * 2 \->LIST
\>>
//
/Var Q
@ variable
4.96764338347E-2
//
/Var R
@ variable
.015625
//
/Var REMOVE
@ speed feed removal EQ
'cuin=ipm*depth*width'
//
/Var rpm
@ variable
1200
//
/Var S1
@ variable
.1
//
/Var S2
@ variable
.1
//
/Var SCREW
@ screw number size EQ defined
\<<
   \-> X
   '.06+.013*X'
\>>
//
/Var screw
@ variable
\<<
   \-> Y
   '-4.61538461539+76.9230769231*Y'
\>>
//
/Var SDRILL
@ screw drill
\<<
   RCLF \-> n t f
   \<<
      f STOF " " n \->STR + " " + STD t \->STR +
      \-> s
      \<<
         f STOF 20 SF
         n DUP t TAP SWAP THRU EVAL 22 SF DRILL "THRU" s +
         8 1 2 GDISP 0 WAIT
         DROP EVAL 22 SF DRILL "TAP" s +
         8 1 2 GDISP 0 WAIT DROP f STOF
      \>>
   \>>
\>>
//
/Var SOLVR
@ solver menu
\<<
   30 MENU
\>>
//
/Var SPEED
@ feed speed EQ
'fpm=rpm*dia*\pi/12'
//
/Var TAG\->
@ similar to 'S\->V' in HOME
\<<
   OBJ\-> S\->V
\>>
//
/Var TAP
@ find tap
\<<
   RCLF
   \-> f
   \<<
      DEG .75 .75 * 60 TAN * SWAP / -
      f STOF
   \>>
\>>
//
/Var TDPTH
@ tap thread depth
\<<
   INV 3 \v/ 2 / .75 * *
\>>
//
/Var teeth
@ variable
2
//
/Var THRU
@ screw thru adjustment
\<<
   1.032 *
\>>
//
/Var tmenu
@ temp HMS menu
\<<
   { \->HMS HMS\-> HMS+ HMS- } TMENU
\>>
//
/Var width
@ variable
.25
//
/Var WIRE
@ wire size ED defined
\<<
   \-> X
   '.324843961*EXP(-(.115940155*X))'
\>>
//
/Var wire
@ wire size EQ defined
\<<
   \-> Y
   '-9.6981958662-8.62513940921*LN(Y)'
\>>
//
/Var XX
@ ???
\<<
   \-> A B
   '\v/((A^2+B^2)/2-A*B)'
\>>
//
/Var YY
@ ???
\<<
   \-> A B
   '(A+B)/\v/2'
\>>
