// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN MISC }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN MISC }
misc stuff
//
/Var \->TEL
@ number to 3 letter telephone
@  1 Q     2 ABC   3 DEF
@  4 GHI   5 JKL   6 MNO
@  7 PRS   8 TUV   9 WXY
@          0 Z
\<<
   { "Z" "Q" "ABC" "DEF" "GHI" "JKL" "MNO" "PRS" "TUV" "WXY" }
   RCLF
   \-> l f
   \<<
      STD \->STR
      DO
         \-> s
         \<<
            l s HEAD OBJ\-> 1 + GET s TAIL DUP "" ==
         \>>
      UNTIL
      END
      DROP f STOF
   \>>
\>>
//
/Var A\177B
@ good for tolerances
\<<
   \-> A B
   \<<
      A B - A B +
   \>>
\>>
//
/Var AB\177C
@ something I used once that needed repetition
\<<
   \-> A B C
   \<<
      A C + B C -
   \>>
\>>
//
/Var CODE
@ code a number with key #
\<<  RAND 9 * CEIL \-> r
   \<<
      r RDZ "" SWAP
      DO
         \-> s
         \<<
            s HEAD OBJ\-> RAND 10 * CEIL 1 - + 10 MOD \->STR +
            s TAIL
            DUP "" ==
      \>>
      UNTIL
      END
      DROP r
   \>>
\>>
//
/Var CST
misc
//
/Var DCODE
@ decode a coded number
@ with modification this will work for text
\<<
   RDZ "" SWAP
   DO
      \-> s
      \<<
         s HEAD OBJ\-> RAND 10 * CEIL 1 - - 10 MOD
         \->STR +
         s TAIL
         DUP "" ==
      \>>
   UNTIL
   END
   DROP
\>>
//
/Var ERR
@ tagged error messages starting at 'err' + 1
@ uses: err
@ any key quits but needs repeated tapping due to err trapping
@ WARNING: this prgm will run until stopped or out of memory or a bad msg
@ I used this to complete the err msg table in the manual
\<<
   CLLCD
   DO
      'err' INCR R\->B DUP 6 DISP      @ counter display
      IFERR
         DOERR                         @ some err msg's end the prgm
      THEN
         IF
            ERRM "" \=/                @ skip blank err msg's
         THEN
            ERRM ERRN \->STR \->TAG    @ tagged err msg left on stack
            ERRN 3 DISP ERRM 4 DISP    @ err msg displayed
         END
      END
   UNTIL
      KEY                              @ needs repeated tapping
   END
   DROP
\>>
//
/Var err
@ used by: ERR
59864
//
/Var fmnu
@ TMENU used by FMNU
@ flag name, list #, flag
{
   { "SOL\.x" \<< 1  -1 FMNU \>> }
   { "CON\.x" \<< 2  -2 FMNU \>> }
   { "NUM\.x" \<< 3  -3 FMNU \>> }
   { "V\->2\.x" \<< 4 -19 FMNU \>> }
   { "SND\.x" \<< 5 -56 FMNU \>> }
   { "ALM\.x" \<< 6 -57 FMNU \>> }
}
//
/Var FMNU
@ toggle flag disp str chr
@ called by TMENU 'fmnu'
\<<
   \-> p f
   \<<
      'fmnu' DUP p DUP2 GET 1 DUP2 GET 1 3 SUB
      IF
         f FC?C
      THEN
         f SF "\[]"
      ELSE
         "\.x"
      END
      + PUT PUT
   \>>
   TMENU
\>>
//
/Var FMNUI
@ initializes 'fmnu'
\<< 'fmnu' 1 \-> l i
   \<<
      l i
      DO
         GET OBJ\-> DROP               @ get TMENU item
         OVER i 1 - 7 MOD 1 + DISP     @ disp curr item
         \->STR DUP "FMNU" POS 2 - 3   @ get flg # from prgm element
         SWAP SUB OBJ\-> SWAP DROP
         4 SWAP                        @ str flg index
         IF
            FC?
         THEN
            "\.x"                      @ clr
         ELSE
            "\[]"                      @ set
         END
         REPL l i GET 1 ROT PUT        @ set flg str
         l i ROT PUTI DUP 'i' STO      @ save flg & index
      UNTIL
         -64 FS?
      END
   \>>
   DROP2
\>>
//
/Var FSET
@ > > > OBSOLETE < < <
@ sets flg str based on 'fmnu' using FMNU
@ I wrote a new prgm FMNUI to set the str's & runs with the TMENU
\<<
   CLLCD 'fmnu' 1
   DO
      GETI OBJ\-> DROP SWAP 1 DISP DUP EVAL EVAL
   UNTIL
      -64 FS?
   END
   DROP2
\>>
//
/Var misc
{
   { GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
   REG      MINEHUNT    Nmines
   { "FMNU" \<< FMNUI fmnu TMENU \>> }
   FSET     A\177B         AB\177C        PERTBL      PERFIND
   EQNLIB   CONLIB      MATRIX      PRINT       SOLVE
   menu
   { GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
   { GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var NOTES
@ plays several octaves of 'scale' list
\<<
   CLLCD 'scale' 1
   -3 4
   FOR N
      DO
         GETI N SWAP .1 NOTE
      UNTIL
         -64 FS?
      END
   NEXT
   DROP2
\>>
//
/Var PERALL
@ all items from periodic table
@ uses PERLIST
@ NOT included with the 48GX
@ included with the 48SX Solve Equation Card
@ why...? I did download a new ver for the 48GX
\<< \-> N
  \<< 1 25
    FOR I 'PERLIST'
I GET ": " + N I
PTPROP \->STR + I 7
MOD1 \-> L
      \<<
        IF 21 FS?
        THEN PR1
        END DUP L DISP
" - - - - - - - - - - "
L 1 + 7 MOD1 DISP
      \>>
    NEXT
  \>> 3 WAIT
\>>
//
/Var PERDISP
@ graphic display of element fo select items
@ could use my GDISP but I think this was done before that
\<<
   \-> E
   \<<
      E 24 PTPROP "NAME " \->TAG
      E 25 PTPROP "SYMB " \->TAG
      E 13 PTPROP "GROUP" \->TAG
      E 14 PTPROP "FAM  " \->TAG
      E  2 PTPROP "MASS#" \->TAG
      E  1 PTPROP "AT#  " \->TAG
      E  3 PTPROP "ATWT " \->TAG
      E  4 PTPROP "DEN  " \->TAG
      E  7 PTPROP "STATE" \->TAG
      E  6 PTPROP "ECFG " \->TAG
   \>>
      # 131d # 64d PDIM ERASE { # 0d # 0d } PVIEW
      10 1
      FOR
         L L 1 1 GDISP -1
      STEP
\>>
//
/Var PERFIND
@ find an element by name ie. Hydrogen, Boron, etc.
@ uses PERDISP
\<<
   \-> S
   \<<
      1 106
      FOR N
         N 1 DISP
         IF
            N 24 PTPROP S POS
         THEN
            N \->STR ":" + N 25 PTPROP ":" + + N 24 PTPROP +
            DUP CNTR2 2 DISP N PERDISP { } PVIEW KILL
         END
      NEXT
   \>>
\>>
//
/Var PERLIST
@ used by PERALL
{
" at #" " mass" "at wt" "  den" "ox st"
"confg" "state" " melt" " boil" "h vap"
"h fus" "sp ht" "  grp" "  fam" "cryst"
"at vo" "at rd" "co rd" "t con" "e con"
"ion p" "e neg" "   ox" " name" " symb"
}
//
/Var QSRT
@ Quick Sort - recursive
@     divides the list in two then again & again
@     drops out when nothing left to sort
@     then combines the lists over & over until done
@     been a while since I programmed this
@ since the GX has SORT & Donnelly's Toolkit has QSORT it is redundant
@     but I did it anyway, a simple one at least
@ GX sorts lists, Donnlly's sorts stack meta objects
@     these two are System RPL and much, much faster
\<<
   MEM 3 DISP                          @ display memory
   IF DUP SIZE 1 >                     @ if sortable list
      THEN
         DUP HEAD                      @ get first element, pivot
         SWAP TAIL                     @ get remainder elements
         { } { }                       @ empty sorting lists
         RCLF                          @ save flg esp for eol
         \-> h t l g f
         \<<
            't' 1                      @ sort the list
            DO
               GETI
               IF h OVER >
                  THEN                 @ less than pivot
                     l + 'l' STO
                  ELSE                 @ greater than pivot
                     g + 'g' STO
               END
            UNTIL
               -64 FS?
            END
            DROP2                      @ \>> \>> \>> start of recursion \<< \<< \<<
            l QSRT                     @ sort less than list
            h +                        @ concatenate less than & pivot
            g QSRT +                   @ sort greater than list & concatenate
            f STOF                     @ restore flg
         \>>
   END
\>>
//
/Var QSRTS
@ Quick Sort - static
@ a static version of QSRT only necessary for huge lists
@ uses: QSWAP
\<<
                                       @ hmmm...
\>>
//
/Var QSWAP
@ list element swapping
\<<
   \-> l i j
   \<<
      'l' i GET
      'l' j GET
      'l' i ROT PUT
      'l' j ROT PUT
      l
   \>>
\>>
//
/Var TEL\->
@ letter string to telephone number
@  1 Q     2 ABC   3 DEF
@  4 GHI   5 JKL   6 MNO
@  7 PRS   8 TUV   9 WXY
@          0 Z
\<<
   "" SWAP
   DO
      \-> s
      \<<
         "22233344455566671778889990"
         s HEAD NUM 64 - DUP SUB + s TAIL DUP "" ==
      \>>
   UNTIL
   END
   DROP
\>>
//
/Var TLLIB
@ James Donnelly's Toolkit Menu - categorized
@ some items repeat since they are multicategory
\<<
   {
      { "\->ARY"                       @ 1
         \<<
            {
            DELCOL   DELROW   EXCOL    EXROW    GETCOL   GETROW
            INSCOL   INSROW   PUTCOL   PUTROW   { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->GPH"                       @ 2
         \<<
            {
            PX+      PX-      PXOFF    PXON     PX?      PX\->R
            ROTATE   R\->PX     { }      { }      { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->LST"                       @ 3
         \<<
            {
            CAR      CDR      CUT      EXTRACT  LSORT    NXTOB
            PRVOB    REPLACE  REVERSE  ROTATE   \->SET     SPLIT
            { }      { }      { }      { }      { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->MTA"                       @ 4
         \<<
            {
            MAH      MAT      MDH      MDT      MREVERSE QSORT
            MAH2     MAT2     MDH2     MDT2     MSWAP    MAM2
            MZ2      ML\->M     MM\->L     { }      { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->SET"                       @ 5
         \<<
            {
            ADJOIN   DIFF     INTERSECT SDIFF   \->SET     UNION
            { }      { }      { }       { }     { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->STK"                       @ 6
         \<<
            {
            KEEP     MREVERSE NDUP     QSORT    SRLL     SRLLD
            SXCH     { }      { }      { }      { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->STR"                       @ 1
         \<<
            {
            CAR      CDR      CUT      ICAPS    LCASE    LTRIM
            PUTCHR   REPLACE  REVERSE  ROTATE   RPTSTR   RTRIM
            SPLIT    \->STDSTR  STRCON   STRCTR   SUBNUM   \->TIO
            TIO\->     TRIM     UCASE    \->WORDS   { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { "\->OTH"                       @ 2
         \<<
            {
            DOW      DOY      EQNVARS  VFIND    XTIME    TLVER
            { }      { }      { }      { }      { }      { "\<---" { TLLIB } }
            }
            TMENU
         \>>
      }
      { } { } { } { "TLLIB"  \<< 776.01 MENU \>> }  @ 3,4,5,6
   }
   TMENU
\>>
