// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN TIMFN }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN TIMFN }
various time functions

dow & doy are duplicated somewhat in ASTRO: DOW1 & DOY1
but the ASTRO functions use Julian Dates

I had analog clocks but they took up a lot of space
they are still in the HP folders but not here yet

ACC is a third party analog clock I use
//
/Var \->10STR
@ pad #
@ I wrote another prgm PAD that will do any # of places
\<<
   \-> N
   \<<
      N \->STR
      IF N 10 <
         THEN
            "0" SWAP +
      END
   \>>
\>>
//
/Var \->tag
@ tag w/o ::, just a trainling :
@ use for displaying items w/o leading :
\<<
   \->STR ": " + SWAP +
\>>
//
/Var \GDDAYS
@ delta days to target date
@ uses: TD
\<<
   RCLMENU RCLF
   \-> m f
   \<<
      "Target Date?" 10 CHR + "   " +
      IF -42 FS?
         THEN
            "dd.mmyyyy"
         ELSE
            "mm.ddyyyy"
      END
      + STD TD "TD" \->TAG \->STR -6 2 \->LIST 28 MENU
      INPUT
      CLLCD OBJ\-> TAGSTO DATE TD DDAYS \->STR " Days" +
      3 DISP 2 FREEZE f STOF m MENU
   \>>
\>>
//
/Var AGEDAYS
@ my age in days
\<<
   RCLF -42 SF 27.101956 DATE DDAYS SWAP STOF
\>>
//
/Var ALLTIME
@ all time display
@ uses: \->tag
\<<
   DATE TIME JULIAN RCLF \-> D T J F
   \<<
      D D\->STR "  Date" \->tag
      D doy STD \->STR "   DOY" \->tag
      D dow W\->STR "   DOW" \->tag
      T T\->STR "  Time" \->tag
      J 6 FIX \->STR "Julian" \->tag
      F STOF
      7 3
      FOR N
         N DISP
      -1 STEP
      2 FREEZE
   \>>
\>>
//
/Var alltime
@ running clock
@ uses: ALLTIME
\<<
   RCLF
   DO
      DO
         ALLTIME
      UNTIL
         KEY
      END
      IF 51 ==
         THEN
            OFF 0
         ELSE
            1
      END
   UNTIL
   END
   STOF
\>>
//
/Var ALRM
@ I guess this finds & displays alarms
@ the GX now has interactive display & edit forms
\<<
   0 "" 127 CHR
   \-> I S C
   \<<
      IF 1 FS?C
         THEN
            DATE TIME 2 \->LIST FINDALARM
            IF DUP 0 >
               THEN
                  1 -
            END
            'I' STO
      END
      RCLF 2 FIX
      1 22
      START
         C 'S' STO+
      NEXT
      3 7
      FOR N
         S N DISP
      NEXT
      1 SF
      DO
         'I' INCR
         IFERR RCLALARM
            THEN
               1 CF
            ELSE
               \-> L
               \<<
                  L 1 GET L 2 GET TSTR L 3 GET "RPT: " L 4 GET "T"
               \>>
               IF OVER 8192 \>=
                  THEN
                     DROP 8192 / "S"
               END
               IF OVER 60 \>=
                  THEN
                     DROP 60 / "M"
               END
               IF OVER 60 \>=
                  THEN
                     DROP 60 / "H"
               END
               IF OVER 24 \>=
                  THEN
                     DROP 24 / "D"
               END
               IF OVER 7 \>=
                  THEN
                     DROP 7 \047 "W"
               END
               SWAP \->STR " " + SWAP + +
               6 DISP 5 DISP 4 DISP 0 WAIT DROP
         END
      UNTIL
         1 FC?
      END
      DROP
   \>>
   STOF
\>>
//
/Var BCLOCK
@ bargraph clock
\<<
   RCLF STD ERASE { # 0d # 0d } PVIEW
   "SECOND" "MINUTE" "HOUR" "DAY" "MONTH" "YEAR"
   1 6
   FOR N
      N 1 1 GDISP
   NEXT
   22 10 \-> L O
   \<<
      0 L 2 / IP
      FOR N
         N 10 MOD 7 N 2 * O + .5 - 1 GDISP
      NEXT
      DO
         DATTIM DATE TIME TSTR 'dattim' 1
         DO
            \-> I
            \<<
               I GETI
               CASE
                  I 1 ==
                  THEN
                     100 / FP
                  END
                  I 2 ==
                  THEN
                     1 - 11 /
                  END
                  I 3 ==
                  THEN
                     1 - 30 /
                  END
                  I 4 ==
                  THEN
                     24 \047
                  END
                  I 5 ==
                  THEN
                     60 \047
                  END
                  I 6 ==
                  THEN
                     60 \047
                  END
               END
               L BGPH I O 1 GDISP
            \>>
         UNTIL
            -64 FS?
         END
         DROP2 9 8 1 GDISP
      UNTIL
         KEY
      END
      DROP STOF
   \>>
\>>
//
/Var CAL
@ graphical calendar display
@ this is a new version I wrote
@ input: date
@ uses: DOWZ, YMD, \->STRN
\<<
   YMD
   {
      "JAN" "FEB" "MAR" "APR"
      "MAY" "JUN" "JUL" "AUG"
      "SEP" "OCT" "NOV" "DEC"
   }
   { "M" "T" "W" "R" "F" "S" "N" }
   RCLF
   \-> y m d t h f
   \<<
      STD
      -42 SF
      PICT PURGE
      { # 0d # 0d } PVIEW
      y DTAG \->STR " " + t m GET +    @ date header
      " " + d DTAG 1 \->STRN +
      1                                @ row
      1                                @ col
      2 GDISP
      1 7 FOR n                        @ week header
         h n GET
         2                             @ row
         n 1 - 3 * 2 +                 @ col
         2 GDISP
      NEXT
      y 10000 / m + 100 / 1 +          @ date first day
      DUP DOWZ                         @ offset
      \-> q o
      \<<
         0 30
         FOR n
            q n DATE+                  @ date indexing
            \-> x
            \<<
               IF                      @ disp curr month
                  x FP 100 * IP m ==
               THEN
                  x IP 1 \->STRN
                  n o + 7 / IP 2 + 1 +  @ row
                  x DOWZ 3 * 1 +       @ col
                  2 GDISP
               END
            \>>
         NEXT
      \>>
      f STOF
   \>>
   { } PVIEW
\>>
//
/Var clkadj
@ clock adjust menu
@ uses: H, M, S
\<<
   8192 'S' STO
   S 60 * 'M' STO
   M 60 * 'H' STO
   {
      { "\<<<" \<< H NEG CLKADJ \>> }
      { "\<<"  \<< M NEG CLKADJ \>> }
      { "<"  \<< S NEG CLKADJ \>> }
      { ">"  \<< S CLKADJ \>> }
      { "\>>"  \<< M CLKADJ \>> }
      { "\>>>" \<< H CLKADJ \>> }
   }
   TMENU
\>>
//
/Var D\->STR
@ convert date to string
\<<
   RCLF \-> F
   \<<
      STD
      1 2
      START
         IPFP 100 * SWAP
         \-> N
         \<<
            N \->STR
            IF -42 FS?
               THEN
                  "."
               ELSE
                  "/"
            END
            +
            IF N 10 <
               THEN
                  "0" SWAP +
            END
         \>>
         SWAP
      NEXT
      100 * \->STR + + F STOF
   \>>
\>>
//
/Var dattim
@ date time array
@ used by: DATTIM
[ 2012 10 26 23 5 16 ]
//
/Var DATTIM
@ makes an array [ yyyy mm dd hh mm ss ]
@ uses: dattim
\<<
   DATE IPFP 100 * IPFP 10000 *
   1 3
   FOR N
      IF N 2 ==
         THEN
         IF -42 FC?
            THEN
               SWAP
         END
      END
      'dattim' N ROT PUT
   NEXT
   TIME
   4 6
   FOR N
      IPFP SWAP 'dattim' N ROT PUT 100 *
   NEXT
   DROP
\>>
//
/Var dow
@ day of week #
@ M=1 ...  N=7
\<<
   1.011900 SWAP DDAYS 7 MOD 1 +
\>>
//
/Var DOWZ
@ dow zero
@ uses: James Donnelly's Toolkit DOW
\<<
   DOW 1 -
\>>
//
/Var doy
@ day of year
\<<
   \-> D
   \<<
      D 100 * FP 100 \047 1.01 + D DDAYS 1 +
   \>>
\>>
//
/Var H
@ hour ticks
29491200
//
/Var M
@ minute ticks
491520
//
/Var mo
@ conversion unit
'8.33333333333E-2_yr'
//
/Var S
@ second ticks
8192
//
/Var T\->STR
@ convert time to string
\<<
   RCLF \-> F
   \<<
      STD
      1 2
      START
         IPFP 100 * SWAP \->10STR ":" + SWAP
      NEXT
      2 FIX \->10STR + + F STOF
   \>>
\>>
//
/Var TD
@ target date
@ used by: \GDDAYS
9.122012
//
/Var time
@ time Fx menu
\<<
   {
      DATE                             @ built-in
      TIME                             @ built-in
      TSTR                             @ built-in
      DOW                              @ Donnelly's Toolkit
      DOY                              @ Donnelly's Toolkit
      JULIAN                           @ my prgm
      DATE+                            @ built-in
      DDAYS                            @ built-in
      \->HMS                           @  built-in
      HMS\->                           @ built-in
      HMS+                             @ built-in
      HMS-                             @ built-in
      '1_yr' '1_mo' '1_wk' '1_d'       @ unit conversions
      '1_h' '1_min' '1_s' '1_kh'       @ unit conversions
   }
   TMENU
\>>
//
/Var timfn
@ custon menu
{
   { GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1 UPDIR }
   CAL ACC CLOCK alltime ALLTIME AGEDAYS \GDDAYS
   { "SW" \<< 768.01 MENU \>> }
   ALRM
   { "CLKADJ" clkadj }
   time
   { GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1 ABITCH }
   { GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0 EXE }
}
//
/Var W\->STR
@ week string
\<<
   {
      "<M>ONday"
      "<T>UEsday"
      "<W>EDensday"
      "THu<R>sday"
      "<F>RIday"
      "<S>ATurday"
      "SU<N>day"
   }
   SWAP GET
\>>
//
/Var wk
@ conversion unit
'7_d'
//
/Var YMD
@ break date into parts
@ input: date
\<<
   IPFP 100 * IPFP 10000 * "Y" \->TAG 3 ROLLD
   IF
      -42 FC?
   THEN
      SWAP
   END
      "M" \->TAG SWAP "D" \->TAG
\>>
