// HP 48 Program Development Link Application
//
/Angle Degrees
/FractionMark .
/InstallDir { HOME MAIN TRI }
/AutoExec
//
/Var \->\->NOTES
@ { HOME MAIN TRI }
TRIANGLE SOLUTIONS
AAS   angle angle side
ASA   angle side  angle
SAS   side  angle side
SSA   side  side  angle
SSS   side  side  side
//
/Var \Gg
@ angle C
90
//
/Var \Ga
@ angle A
36.8698976458
//
/Var \Gb
@ angle B
53.1301023542
//
/Var A
@ area
6
//
/Var a
@ side A
3
//
/Var AAS
@ angle-angle-side triangle solution
\<<
   "AAS: \Ga \Gb a" { \Ga \Gb a }
   input
   180 \Ga \Gb + - '\Gg' STO a \Ga SIN \047
   \-> k
   \<<
      k \Gb SIN * 'b' STO
      sk \Gg SIN * 'c' STO
   \>>
   AREA
   disp
\>>
//
/Var AREA
@ area
\<<
   a b c S
   \-> s
   \<<
      '\v/(s*(s-a)*(s-b )*(s-c))' EVAL 'A' STO
   \>>
\>>
//
/Var ASA
@ angle-side-angle  triangle solution
\<<
   "ASA: \Ga c \Gb" { \Ga c \Gb }
   input
   180 \Ga \Gb + - '\Gg' STO c \Gg SIN \047
   \-> k
   \<<
      k \Ga SIN * 'a' STO
      k \Gb SIN * 'b' STO
   \>>
   AREA
   disp
\>>
//
/Var b
@ side B
4
//
/Var c
@ side C
5
//
/Var CST
tri
//
/Var disp
@ display values
@ uses 'graph' in HOME dir
\<<
   WORKING eval 8 CNTR2 5 DISP # 83h # 40h PDIM ERASE
   "GRAPHIC DISPLAY OF ALL VALUES"
   1 1 1 GDISP { a b c \Ga \Gb \Gg A } 1
   DO
      DUP
      \-> i
      \<<
         8 i - CNTR2 5 DISP
         GETI DUP EVAL EVAL SWAP \->STR 2 OVER SIZE 1 - SUB 2 RJST \->TAG
         i 1 + 1 2 GDISP
      \>>
   UNTIL
      -64 FS?
   END
   DROP2 22 CF graph TEXT CLLCD
\>>
//
/Var eval
@ EVAL all variables
\<<
   { A a b c \Ga \Gg \Gb } 1
   DO
      GETI DUP EVAL EVAL SWAP STO
   UNTIL
      -64 FS?
   END
   DROP2
\>>
//
/Var input
@ SX/GX input style, GX is chosen
\<<
   inputF
\>>
//
/Var rnd
@ round all variables
\<<
   { A a b c \Ga \Gg \Gb } 1
   DO
      GETI DUP EVAL 10 RND SWAP STO
   UNTIL
      -64 FS?
   END
   DROP2
\>>
//
/Var S
@ triangle S value
\<<
   \-> a b c '(a+(b+c) )/2'
\>>
//
/Var SAS
@ side-angle-side triangle solution
\<<
   "SAS: a \Gg b" { a \Gg b }
   input
   a SQ b SQ + 2 a b \Gg COS * * * - \v/ 'c' STO
   c \Gg SIN /
   \-> k
   \<<
      a k / ASIN '\Ga' STO
      b k / ASIN '\Gb' STO
   \>>
   AREA
   disp
\>>
//
/Var SSA
@ side-side-angle triangle solution
\<<
   "SSA: a b \Ga" { a b \Ga }
   input
   a \Ga SIN \047
   \-> k
   \<<
      180 b k / ASIN - '\Gb' STO
      180 \Ga \Gb + - '\Gg' STO k \Gg SIN * 'c' STO
   \>>
   AREA disp \Gb \Ga - '\Gg' STO
   180 \Gb - '\Gb' STO
   a \Gg SIN * \Ga SIN \047 'c' STO
   AREA
   disp
\>>
//
/Var SSS
@ side-side-side triangle solution
\<<
   "SSS: a b c" { a b c } input b SQ c SQ + a SQ - 2 b c * * / ACOS '\Ga' STO
   a SQ c SQ + b SQ - 2 a c * * / ACOS '\Gb' STO
   a SQ b SQ + c SQ - 2 a b * * / ACOS '\Gg' STO
   AREA
   disp
\>>
//
/Var tri
{ {
GROB 21 8 FFFFF1100001DAA3215A2161D429F15A2161DA2121FFFFF1
UPDIR } AAS ASA SAS
SSA SSS disp {
PICTURE
\<< 22 CF graph
\>> } { VARS
\<< { a b c \Ga \Gb \Gg A }
TMENU
\>> } {
GROB 21 8 FFFFF1100001DFBF7150AF7150AF71DFBF71100001FFFFF1
ABITCH } {
GROB 21 8 EFFFF020F180AF0EB020F180AF0EB0EFFFF0294290EFFFF0
EXE } }
